;@goto translate


.586P

.MODEL            FLAT, STDCALL

   OPTION         CASEMAP: NONE

   INCLUDE        WINDOWS.INC
   UNICODE        = FALSE
   INCLUDE        APIMACRO.mac

   INCLUDELIB     iKERNEL32.lib
   INCLUDELIB     iUSER32.lib
   INCLUDELIB     iADVAPI32.lib

   INCLUDE        Secrty.INC


.DATA
   NewState        LABEL  TOKEN_PRIVILEGES
                   DWORD  1
   dbLUID          LUID_AND_ATTRIBUTES  <<0, 0>, SE_PRIVILEGE_ENABLED>

   ExplicitAccess  LABEL  EXPLICIT_ACCESS
    DWORD          KEY_ALL_ACCESS
    DWORD          SET_ACCESS
    DWORD          NO_INHERITANCE 
   Trustee TRUSTEE <NULL, NO_MULTIPLE_TRUSTEE, TRUSTEE_IS_NAME, TRUSTEE_IS_USER,\
                    ststName>
   pTrustee        EQU OFFSET Trustee
   pExplicitAccess EQU OFFSET ExplicitAccess

   TEXT   tstName, <CURRENT_USER/0>

.DATA?

   OFFDU  MACRO VarName
    VarName DWORD ?
    p&VarName EQU OFFSET VarName
          ENDM 

   OFFDU  pDacl
   OFFDU  pSecurityDescriptor



.CODE

   hProc    EQU -1
  
   TEXT     zSE_SECURITY, <SeSecurityPrivilege/0>

 Start:
   SUB      EBP, EBP 
   iWin32i  LookupPrivilegeValue, EBP, szSE_SECURITY, OFFSET dbLUID
   TEST     EAX, EAX
   JE       @F
   PUSH     EAX
   iWin32   OpenProcessToken, hProc, TOKEN_QUERY OR TOKEN_ADJUST_PRIVILEGES, ESP
   TEST     EAX, EAX
   POP      EDI
   JE       @F
   iWin32   AdjustTokenPrivileges, EDI, EBP, OFFSET NewState, EBP, EBP, EBP
   iWin32   CloseHandle, EDI  
  @@:

   iWin32   GetCommandLineA
   MOV      EDI, EAX
   MOV      AL, [EDI]
   INC      EDI
   CMP      AL, '"'
   JE       @F
   DEC      EDI
   MOV      AL, ' '
  @@:
   OR       ECX, -1 
   REPNE    SCASB
  @@:
   MOV      AL, [EDI]
   CMP      AL, ' '
   JNE      @F
   INC      EDI
   JMP      @B
  @@:
   MOV      ESI, EDI
   CMP      AL ,'"'
   JNE      @F
   INC      EDI
   INC      ESI
   REPNE    SCASB
   AND      BYTE PTR [EDI-1], 0
  @@:
   ;in ESI is reg key
   LODSD
   MOV      EBX, HKEY_CLASSES_ROOT
   CMP      EAX, "RCKH"
   JE       Found
   INC      EBX
   CMP      EAX, "UCKH"
   JE       Found
   INC      EBX
   CMP      EAX, "MLKH"
   JE       Found
   INC      EBX
   CMP      EAX, "SUKH"
   JE       Found
   INC      EBX
   INC      EBX
   CMP      EAX, "CCKH"
   JNE      Exit  
  Found:
   LODSB

   sWin32   SetKeyAllAccess, EBX, ESI
   PUSH     EAX
   iWin32i  RegOpenKeyEx, EBX, ESI, NULL, STANDARD_RIGHTS_READ OR KEY_ENUMERATE_SUB_KEYS, ESP
   TEST     EAX, EAX
   POP      EDI
   JNE      Exit
   sWin32   DoSubKeys, EDI
   iWin32   RegCloseKey, EDI
   iWin32   RegCloseKey, EBX
  Exit:   
   iWin32   ExitProcess, EAX


 SetKeyAllAccess PROC USES EBX ESI EDI, hKey, KeyName
   SUB      ESI, ESI
   PUSH     EAX
   iWin32i  RegOpenKeyEx, hKey, KeyName, NULL, STANDARD_RIGHTS_READ, ESP
   TEST     EAX, EAX
   POP      EDI
   JNE      Failed

   iWin32   GetSecurityInfo, EDI, SE_REGISTRY_KEY, DACL_SECURITY_INFORMATION,\
                             ESI, ESI, ppDacl, ESI, ppSecurityDescriptor
   TEST     EAX, EAX
   JNE      FailedAndClose

   PUSH     EAX
   iWin32i  SetEntriesInAcl, 1, pExplicitAccess, pDacl, ESP
   POP      EBX
   TEST     EAX, EAX
   JNE      FailedAndCloseFree

   iWin32   SetSecurityInfo, EDI, SE_REGISTRY_KEY, DACL_SECURITY_INFORMATION,\
                             ESI, ESI, ESI, EBX
   PUSH     EAX
   iWin32   LocalFree, EBX
   POP      EAX 
  FailedAndCloseFree:
   PUSH     EAX 
   iWin32   LocalFree, pSecurityDescriptor
   POP      EAX
  FailedAndClose:
   PUSH     EAX
   iWin32   RegCloseKey, EDI
   POP      EAX
  Failed:
   RET 
 SetKeyAllAccess ENDP


 DoSubKeys  PROC  USES EBX ESI EDI, hKey
   LOCAL    SubKeyName[2044] :SIGN 
   SUB      EDI, EDI
   LEA      ESI, SubKeyName
  @@:
   iWin32i  RegEnumKey, hKey, EDI, ESI, 2044
   ;CMP      EAX, ERROR_NO_MORE_ITEMS
   ;JE       KeyDone
   TEST     EAX, EAX
   JNE      KeyDone
   sWin32   SetKeyAllAccess, hKey, ESI
   PUSH     EAX
   iWin32i  RegOpenKeyEx, hKey, ESI, NULL, STANDARD_RIGHTS_READ OR KEY_ENUMERATE_SUB_KEYS, ESP
   INC      EDI
   TEST     EAX, EAX
   POP      EBX
   JNE      @B
   sWin32   DoSubKeys, EBX
   iWin32   RegCloseKey, EBX
   JMP      @B
  KeyDone:
   RET
 DoSubKeys  ENDP


END Start

:translate
@echo off
ML    /c /coff /nologo AllowKey.bat
eLINK AllowKey /nologo  /IGNORE:4078 /SUBSYSTEM:WINDOWS /OPTIDATA /MERGE:.rdata=.text /MERGE:.data=.text /SECTION:.text,EWR
DEL   AllowKey.obj
PAUSE
CLS