;@goto translate


; Freely according to MSDN....


.586P

.MODEL            FLAT, STDCALL

   OPTION         CASEMAP: NONE

   INCLUDE        WINDOWS.INC
   INCLUDE        APIMACRO.mac

   INCLUDELIB     iKERNEL32.lib
   INCLUDELIB     iUSER32.lib
   INCLUDELIB     iADVAPI32.lib



.DATA?
   sd        SECURITY_DESCRIPTOR  <>
             BYTE  1024-SIZEOF SECURITY_DESCRIPTOR DUP (?)

   acl       ACL                  <>         
             BYTE  1024-SIZEOF ACL                 DUP (?)


.CODE

   sTitle    BYTE "Opening myself.. ",0
   ISDFailed BYTE "InitializeSecurityDescriptor failed!",0
   IACFailed BYTE "InitializeAcl failed!",0
   SSDFailed BYTE "SetSecurityDescriptorDacl failed!",0
   SKOFailed BYTE "SetKernelObjectSecurity failed!",0
   Failed    BYTE "FAILED -> Security works!",0
   Succeeded BYTE "SUCCEEDED -> Security failed!",0

 Start:
   ;initialize buffer for SD
   iWin32    InitializeSecurityDescriptor, OFFSET sd, SECURITY_DESCRIPTOR_REVISION
   TEST      EAX, EAX
   MOV       EDX, OFFSET ISDFailed
   JE        @F
   ;initialize buffer for ACL
   iWin32    InitializeAcl, OFFSET acl, 1024, ACL_REVISION2
   TEST      EAX, EAX
   MOV       EDX, OFFSET IACFailed
   JE        @F
   ;add empty ACL to SD -> deny access
   iWin32    SetSecurityDescriptorDacl, OFFSET sd, TRUE, OFFSET acl, FALSE 
   TEST      EAX, EAX
   MOV       EDX, OFFSET SSDFailed
   JE        @F

   ;get process pseudohandle   
   iWin32    GetCurrentProcess  

   ;apply security descriptor on current process
   ;(process = one of kernel objects)
   ;you can of course used analogs: SetUserObjectSecurity, SetFileSecurity,..
   iWin32    SetKernelObjectSecurity, EAX, DACL_SECURITY_INFORMATION,\
                                      OFFSET sd
   TEST      EAX, EAX
   MOV       EDX, OFFSET SKOFailed
   JE        @F


   ;now is this process unopenable
   iWin32    GetCurrentProcessId
   iWin32    OpenProcess, PROCESS_QUERY_INFORMATION, FALSE, EAX
   TEST      EAX, EAX
   MOV       EDX, OFFSET Failed 
   JE        @F
   iWin32    CloseHandle, EAX
   MOV       EDX, OFFSET Succeeded 
  @@:
   iWin32    MessageBoxA, NULL, EDX, OFFSET sTitle, MB_ICONINFORMATION

   iWin32    ExitProcess, NULL

END Start

:translate
@echo off
ML   /c /coff /nologo AntiOpen.bat
LINK AntiOpen /nologo /ALIGN:0X1000 /SUBSYSTEM:WINDOWS /RELEASE /MERGE:.rdata=.text /IGNORE:4108,4078
DEL  AntiOpen.obj
