;@goto translate
;===============================================================================


;It detects (June 1999), for example, ProcDump, TRW, SoftICE when tracing



.586P
.MODEL FLAT,  STDCALL

 OPTION       CASEMAP :NONE

 
 INCLUDE      KERNEL32.INC
 INCLUDE      USER32.INC

 INCLUDELIB   KERNEL32.LIB
 INCLUDELIB   USER32.LIB


 UNICODE      = 0
 ARGUMENTS    = 0
 INCLUDE      W32MAIN.INC


;===============================================================================
.DATA
    xText     BYTE  "Tracing (complex)",0
    Traced    BYTE  "Detected.",0
    NotTraced BYTE  "Not detected.",0
    Catched   BYTE  FALSE 

;===============================================================================
.CODE

 Start:
    ASSUME    FS:@data
    SUB       EAX, EAX              ;EAX = 0 = PTR to SEH chain
    CALL      There                 ;PUSH  OFFSET xHandler

    xHandler  PROC 
              INC  Catched          ;Was I here?
              SUB  EAX, EAX
              RET
    xHandler  ENDP

   There:
    PUSH      FS:[EAX]              ;PUSH  old SEH
    MOV       FS:[EAX], ESP         ;set my SEH


    PUSHFD
    OR        BYTE PTR [ESP+1], 1   ;set Trap Flag in EFlags
    POPFD                           ;trace myself == make EXCEPTION_SINGLE_STEP
    NOP                             ;             == call xHandler

                                    ;so here takes place 
                                    ;"destructive interfence" of two tracings
                                    ;- tracer's and mine
                                    ;             == call tracer's handler
                                    ;                only

                                    ;in EDump, when victim's Trap Flag is set, 
                                    ;is control passed to the original handler

                                    ;I think tracers could handle it similarly

    POP       FS:[EAX]              ;reset old SEH
    POP       EAX                   ;reset initial ESP

    DEC       Catched               ;Was I there?
    JS        Detected              ;no -> interference

    ;above is 44 bytes (43 code, 1 data) and 0 API calls

    INVOKE    MessageBox, NULL, ADDR NotTraced, ADDR xText, MB_ICONINFORMATION
    JMP       @f

   Detected:
    INVOKE    MessageBox, NULL, ADDR Traced, ADDR xText, MB_ICONEXCLAMATION

   @@:
    INVOKE    ExitProcess, 0



END Start

:translate
@echo off
ML /nologo /c /coff DetectTracerComplex.bat
LINK DetectTracerComplex /nologo /SUBSYSTEM:WINDOWS /RELEASE /ALIGN:0X1000 /MERGE:.rdata=.text /MERGE:.data=.text /MERGE:.text=Detect /SECTION:Detect,RWE  /IGNORE:4078,4108
DEL DetectTracerComplex.obj
