;@GOTO TRANSLATE


.586P

.MODEL             FLAT, STDCALL

   OPTION          CASEMAP: NONE


   INCLUDE         WINDOWS.inc
   UNICODE         = FALSE
   INCLUDE         APIMACRO.mac

   INCLUDE         ExVMM.inc

   INCLUDELIB      iKERNEL32.lib
   INCLUDELIB      iUSER32.lib


Ring0CS  = 28H
Ring0DS  = 30H
Ring0ES  = 30H


.CODE

QuasiDDB   VxD_Desc_Block <,,"QS",,,\
                           DDB_HAS_WIN32_SVCS OR \
                           DDB_SYS_CRIT_INIT_DONE OR \
                           DDB_DEVICE_INIT_DONE \
                           ,\ ;OR DDB_DYNAMIC_VXD,\
                           "QUASIVXD",,QuasiControl,,,,,,\
                           ,,QUASI_W32>

 QUASI_W32  DWORD 2, 0
            DWORD QuasiW320, 0
            DWORD QuasiW321, 0


   TEXT     zTitle,   <Quasi VxD available now/:/0>
   TEXT     zMessage, <Press OK to unload./0>


 PrimaryThread:
   CALL     $+5
   POP      EAX
   TEST     EAX, EAX
   JNS      Exit     ;presence in the shared memory is crucial
   

   sWin32   ThreadWorks, VMM SHL 16 + VMM_Add_DDB
   TEST     EAX, EAX
   JE       Exit

   iWin32i  MessageBox, NULL, szMessage, szTitle, NULL

  Failed:
   sWin32   ThreadWorks, VMM SHL 16 + VMM_Remove_DDB
   TEST     EAX, EAX
   JE       Failed   ;never end

  Exit:
   iWin32   ExitProcess, EAX

;--------------------------------------------------------------------
ThreadWorks PROC USES EBX ESI, Cmd
   LOCAL    Ctx  :CONTEXT
   LEA      ECX, Cmd
   PUSH     EAX
   iWin32   CreateThread, NULL, NULL, AddRemoveDDB, ECX, NULL, ESP
   TEST     EAX, EAX
   POP      ECX
   JE       CTfailed
   LEA      ESI, Ctx
   MOV      EBX, EAX
   ASSUME   ESI: PTR CONTEXT
   MOV      [ESI].ContextFlags, CONTEXT_CONTROL OR CONTEXT_INTEGER
  @@:
   iWin32   Sleep, 32
   iWin32   GetThreadContext, EBX, ESI
   CMP      [ESI].regEip, StopHere
   JNE      @B
   MOV      [ESI].regCs,  Ring0CS
   ADD      [ESI].regEip, 2
   MOV      [ESI].regEcx, CS
   iWin32   SetThreadContext, EBX, ESI
   ASSUME   ESI: NOTHING
   iWin32   WaitForSingleObject, EBX, INFINITE
   PUSH     EAX
   iWin32   GetExitCodeThread, EBX, ESP
   iWin32   CloseHandle, EBX
   POP      EAX
  CTfailed:
   RET
ThreadWorks ENDP
;--------------------------------------------------------------------
 AddRemoveDDB PROC USES EDI, Param
   StopHere::
   JMP      $

   PUSHp    ECX, R0Fin

   SUB      ESP, 40H

   MOV      EAX, Param
   MOV      CD20H, 20CDH
   PUSH     [EAX]
   POP      VxDpart
   JMP      $+2

   MOV      EDI, OFFSET QuasiDDB
   CD20H    WORD   0
   VxDpart  DWORD  0
   JNC      @F

   SUB      EAX, EAX
   JMP      @1
  @@:
   PUSH     1
   POP      EAX
  @1:

   ADD      ESP, 40H
   RETF

  R0Fin:
   RET
 AddRemoveDDB ENDP
;--------------------------------------------------------------------

 ASSUME     ESI: PTR DIOCParams

 QuasiControl:
   CMP      EAX, W32_DEVICEIOCONTROL
   JNE      Quit_IOCTL
   MOV      EDX, [ESI].dwIoControlCode
   DEC      EDX
   JS       Quit_IOCTL
   CMP      EDX, MaxQuasiFunc
   CMC
   JNC      @F
   RET
  @@:
   CALL     QuasiFunc[EDX*4]
  Quit_IOCTL:
   SUB      EAX, EAX
   RET

  ALIGN     4
   QuasiFunc    DWORD GetVMMVersion, GetVWIN32Version
   MaxQuasiFunc = LENGTHOF QuasiFunc


  GetVMMVersion:
   VMMcall  Get_VMM_Version
   MOV      EDX, [ESI].lpvOutBuffer
   MOV      ECX, [ESI].lpcbBytesReturned
   MOV      [EDX], EAX
   MOV      DWORD PTR [ECX], 4
   RET

  GetVWIN32Version:
   VxDcall  VWIN32, VWIN32_Get_Version
   MOV      EDX, [ESI].lpvOutBuffer
   MOV      ECX, [ESI].lpcbBytesReturned
   MOV      [EDX], EAX
   MOV      DWORD PTR [ECX], 4
   RET

 ASSUME     ESI: NOTHING

;Win32 services --------------------------------------------

 ASSUME     ECX: PTR Client_Reg_Struc

 QuasiW320  PROC pClRegStr, pcb_s
   MOV      ECX, pClRegStr
   MOV      EAX, CR0
   MOV      [ECX].Client_EAX, EAX
   RET
 QuasiW320  ENDP

 QuasiW321  PROC pClRegStr, pcb_s
   MOV      ECX, pClRegStr
   MOV      EAX, CR3
   MOV      [ECX].Client_EAX, EAX
   RET
 QuasiW321  ENDP

 ASSUME     ECX: NOTHING
;-----------------------------------------------------------

END  PrimaryThread

:TRANSLATE
@ECHO OFF
ML    /c /coff /nologo QuasiExe.bat
eLINK QuasiExe /out:QuasiVxD.exe /IGNORE:4078 /nologo /SUBSYSTEM:WINDOWS /optidata /merge:.rdata=.text /BASE:0XBF1F0000 /SECTION:.text,!P /FIXED:NO
DEL   QuasiExe.obj
PAUSE
CLS