;@GOTO TRAN

.486P

;Win32 API addresses valid for W2K Pro 2195 SP0
_LoadLibraryA = 77E98023H



CODE16 SEGMENT PARA USE16
ASSUME CS: CODE16, DS:CODE16, ES:CODE16, SS:STACK0
Start:
PUSH  CS
POP   DS

MOV   AX, 1687H
INT   2FH
TEST  AX, AX
JNE   Exit
MOV   DPMISeg, ES
MOV   DPMIOfs, DI
MOV   AX, DS:2
SUB   AX, SI
MOV   ES, AX

MOV   EBX, CODE32
SHL   EBX, 4
MOV   FlatOffset, EBX

MOV   EDX, SS
SHL   EDX, 4
ADD   EDX, ESP

AND    DL, NOT 3  ;ESP must be dword aligned for catching exceptions

SUB   EAX, EAX
JMP   $+2
DB    9AH
DPMIOfs DW 0
DPMISeg DW 0
JC    Exit

MOV   DS16,DS
MOV   ES16,DS
MOV   SS16,SS
MOV   SP16,SP

MOV   ECX, CS
PUSH  1BH  EBX
DB    66H
RETF

Exitus:
MOV   DS,  CS:DS16
MOV   ES,  ES16
MOV   SS,  SS16
MOV   SP,  SP16
TEST  EAX, EAX
JLE   Exit

MOV   AH,10H
INT   16H

Exit:
.EXIT

FlatOffset DD ?

DS16 DW ?
ES16 DW ?
SS16 DW ?
SP16 DW ?

CODE16 ENDS

;==========================================================
CODE32 SEGMENT PARA USE32
 ASSUME CS: CODE32, DS:CODE32, ES:CODE32, SS:CODE32
 PUSH  23H  23H  23H  3BH
 POP   FS   DS	 ES   SS
 MOV   ESP, EDX
 PUSH  ECX  LARGE OFFSET Exitus
;==========================================================

 LEA   ECX, [EBX+EipEsp]
 LEA   EAX, [EBX+XcptHere]
 LEA   EDX, [EBX+Catch0E]
 MOV   [ECX], EAX
 MOV   [EBX+Patch], ECX
 SUB   EAX, EAX
 PUSH  EDX  DWORD PTR FS:[EAX]
 MOV   FS:[EAX], ESP
 MOV   FS:[EAX+8], EAX	 ;Set new stack bottom
 MOV   [ECX+4], ESP


 MOV   ESI, 77F00000H	 ;NT4 K32 base
 CMP   WORD PTR [ESI], 'ZM' ;It's not risky when you know this page
			    ;is commited to K32 image in both NT4 and W2K
 JE    NT4
 MOV   ESI, 77E80000H	 ;W2K K32 base
NT4:

 ;now A) find address of GetProcAddress in K32's import table
 ;	 then find other wanted functions via GetProcAddress
 ;or  B) write your own GetProcAddress

 ;let's assume you've found address of LoadLibraryA
 LEA   EAX, [EBX+szDllName]
 PUSH  EAX
 CALL  [EBX+LoadLibraryA]
 TEST  EAX, EAX
 JE    XcptHere

 PUSH  EAX			;That reminds me PharLap TNT:
 MOV   AH, 09H			;interrupts + Win32 API together
 LEA   EDX, [EBX+Loaded]	;but here is allowed only INT 21h.
 INT   21H			;Moreover DOSX can translate pointers
 POP   EAX

XcptHere:
 POP   DWORD PTR FS:[0]
 POP   ECX
;==========================================================
Finito:
 RETF

Catch0E:
 MOV   EAX, OFFSET EipEsp
Patch  EQU  DWORD PTR $-4
 MOV   ECX, [ESP+12]
 MOV   EDX, [EAX]
 MOV   [ECX+0B8H], EDX	;eip
 MOV   EDX, [EAX+4]
 MOV   [ECX+0C4H], EDX	;esp
 SUB   EAX, EAX
 MOV   [ECX+0B0H], EAX	;eax
 RET
;==========================================================
szDllName DB "ApiHooks.dll",0
Loaded DB "DLL loaded", 36

ALIGN 4
LoadLibraryA DD _LoadLibraryA
EipEsp	  DD ?,?
CODE32 ENDS

;================================================================================

STACK0 SEGMENT STACK
DB 32768 DUP (?)
STACK0 ENDS

END  Start
;==============================================================================

:TRAN
@ECHO OFF
TASM /M /Q /T W32DPMI.bat
TLINK /x/3 W32DPMI.obj
DEL W32DPMI.obj
PAUSE
CLS