;@GOTO TRANSLATE

.586P
.MODEL FLAT, STDCALL

 OPTION      CASEMAP:NONE
 UNICODE     = 1
 ARGUMENTS   = 0
 INCLUDE     W32MAIN.INC
 INCLUDE     APIMACRO.MAC
 INCLUDE     NTDDK.INC
 INCLUDE     DEBUGSYS.INC  
 INCLUDELIB  iNTOSKRNL.lib
 INCLUDELIB  iHAL.lib

;===============================================================================
.DATA
   FileObj            OBJECT_ATTRIBUTES <18H,0,OFFSET PUniStr,40H,0,0>

   XADIextensions     BYTE   "DUP",0FFH
   XADIcommands       DWORD  GetInfo, XADIpage, XADIupdate, XADIdump

   Xhelp              BYTE  ".x  *XADI extensions 1999*",13,10,0
   InfoFormat         BYTE  "XADI extensions for SoftICE (Windows NT) <KdDebuggerEnabled:%.2lX | KdDebuggerNotPresent:%.2lX>\n"
                      BYTE  "----------------------------------------\n"
                      BYTE  "| .xd - danger dumper (.xd? for help)  |\n"
                      BYTE  "| .xp - pagein info   (.xp? for help)  |\n"
                      BYTE  "| .xu - update PE img (.xu? for help)  |\n"
                      BYTE  "----------------------------------------\n",0

   InfoParameters     LABEL DWORD
    PageAdr            LABEL DWORD
    KdEnabled          DWORD 0
    KdNPresent         DWORD 0

   PageHelp           BYTE  ".xp: Displays NP pages in form: PAGEIN address.\n.xp: Usage .xp address size\n",0
   PageIn             BYTE  "PAGEIN %0.8LX\n",0

   UpdateHelp         BYTE  ".xu: Updates PE image (offsets, etc..).\n.xu: Usage .xu address [entry]\n",0
   NotPE              BYTE  "That's not PE image!\n",0

   DumpHelp           BYTE  ".xd: Dumper hangs with 50%% probability! Do NOT use!\n.xd: Usage .xd address size fullfilename\n",0
   IrqlAbove          BYTE  ".xd: IRQL must be < 2\n",0
   NeedsPageIn        BYTE  ".xd: Memory not present. Try PAGEIN.\n",0
   CreateFailed       BYTE  ".xd: Can't create file!\n",0
   WriteFailed        BYTE  ".xd: Can't write to file!\n",0


;   What               BYTE  "Start=%0.8lX Size=%0.8lX",13,10,0
  
   ALIGN 4
   FileName           LABEL WCHAR
                      STRING <\??\>
  xFileName           BYTE 252 DUP (?) 

.DATA?
   PUniStr            UNICODE_STRING {?};<>


;   OldStack DWORD ?
;                DWORD 131172 DUP (?)
;   xStack       LABEL DWORD

;===============================================================================
.CODE INIT
even
DriverEntry PROC; USES EBX ESI EDI, DriverObject, RegPath 

  PUSH   EAX
  PUSH   EAX
  SIDT   [ESP]
  MOV    EAX, [ESP+2]
  POP    ECX
  POP    ECX
  TEST   BYTE PTR [EAX+8*41H+5],60H
  JE     DebNotPresent 

  PUSH   EBX
  PUSH   ESI
  PUSH   EDI   
  PUSH   DS_RegisterDotCommand
  POP    EAX
  MOV    BL, 'X'
  MOV    ESI, OFFSET Xhandler
  MOV    EDI, OFFSET Xhelp
  INT    Debug_Serv_Int
  OR     AX, AX
  POP    EDI
  POP    ESI
  POP    EBX
  CWDE
  JE     @f
 DebNotPresent:
  MOV    EAX, STATUS_UNSUCCESSFUL ;NOT_IMPLEMENTED
 @@:
  RET    8
DriverEntry ENDP


;===============================================================================


.CODE
;===============================================================================

EVEN
Xhandler  PROC FAR
   LOCAL  Handle :HANDLE
   LOCAL  StatusBlock: IO_STATUS_BLOCK
;   PUSHAD
   PUSH   DS
   PUSH   ES
   PUSH   FS ;!!!!!!!!!!!!!

;   MOV    OldStack,ESP
;   MOV    ESP, OFFSET xStack

   PUSH   30H
   POP    FS

   PUSH   23H
   POP    ES

   PUSH   23H
   POP    DS

   PUSH   DS_GetCommandLineChar
   POP    EAX
   MOV    BL,1
   INT    Debug_Serv_Int
   AND    AL, NOT 20H
     
   CLD
   PUSH   SIZEOF XADIextensions
   MOV    EDI, OFFSET XADIextensions
   POP    ECX
   REPNE  SCASB
   MOV    EDI, OFFSET InfoParameters
   JMP    [ECX*4+OFFSET XADIcommands]

 GetInfo::
   iMOV   EAX, KdDebuggerEnabled
   iMOV   ECX, KdDebuggerNotPresent
   MOV    EAX, [EAX]
   MOV    ECX, [ECX]
   MOV    KdEnabled, EAX
   MOV    KdNPresent, ECX
   MOV    ESI, OFFSET InfoFormat
   JMP    PrintQuit


 XADIpage::
   PUSH     DS_GetCommandLineChar
   POP      EAX
   MOV      BL,2
   INT      Debug_Serv_Int
   CMP      AL, '?'
   JNE      @f

   MOV      ESI, OFFSET PageHelp
   JMP      PrintQuit
  @@:
   PUSH     DS_EvaluateExpression
   POP      EAX
   INT      Debug_Serv_Int
   MOV      ESI, EBX  ;offset

   PUSH     DS_EvaluateExpression
   POP      EAX
   INT      Debug_Serv_Int

   SUB      EAX, EAX  ;Do not display PAGEIN XXX
   INC      EAX
   CALL     VerifyAddressRange
   JMP      Quit


 XADIupdate::
   PUSH     DS_GetCommandLineChar
   POP      EAX
   MOV      BL,2
   INT      Debug_Serv_Int
   CMP      AL, '?'
   JNE      @f

   MOV      ESI, OFFSET UpdateHelp
   JMP      PrintQuit
  @@:
   PUSH     DS_EvaluateExpression
   POP      EAX
   INT      Debug_Serv_Int

   MOV      ESI, EBX
   SUB      EAX, EAX  ;Do not display PAGEIN XXX
   MOV      EBX, 1000H
   CALL     VerifyAddressRange
   INC      EDX
   JE       NeedsIn

   MOV      EDX, ESI
   ADD      ESI, [ESI+3CH]  ;address of image
   CMP      DWORD PTR [ESI],00004550H
   JE       @f

   MOV      ESI, OFFSET NotPE
   JMP      PrintQuit

VirtualSize equ 8
RVA equ 0Ch
PhysicalSize equ 10h
FileOffset equ 14h

EntryRVA    EQU 28H
FileAlign   EQU 3CH
HeadersSize EQU 54H


  @@:
   PUSH     DS_EvaluateExpression
   POP      EAX
   INT      Debug_Serv_Int  ;eip
   OR       EBX, EBX
   JE       @f
   SUB      EBX, EDX
   MOV      [ESI+EntryRVA], EBX


 @@:
    ;MOV      EDX, ESI  ;PE

    MOVZX    ECX, WORD PTR [ESI+06H]     ; Get NumberOfSections.

; Go to Section Table. Offset is constant (PE header + F8h).
    ADD      ESI, 0F8H
;    MOV      WORD PTR [EDX+HeadersSize],1000H
;    MOV      WORD PTR [EDX+FileAlign],1000H
   @@:       
    CMP DWORD PTR [ESI], 'ssb.'
    JE  NextSec
; Work on VirtualSize & PhysicalSize.
    MOV EAX, [ESI+VirtualSize]
   ; .IF DWORD PTR [EBX+PhysicalSize] < EAX
    CMP EAX, [ESI+PhysicalSize]
    JBE DoRVA 
    MOV [ESI+PhysicalSize], EAX
  DoRVA:
; Work on RVA & FileOffset.
    MOV EAX, [ESI+RVA]
    MOV DWORD PTR [ESI+FileOffset], EAX
  NextSec:
    ADD ESI, 028H
   LOOP @b
   JMP Quit


 XADIdump::
   PUSH     DS_GetCommandLineChar
   POP      EAX
   MOV      BL,2
   INT      Debug_Serv_Int
   CMP      AL, '?'
   JNE      @f

   MOV      ESI, OFFSET DumpHelp

 PrintQuit:
   PUSH     DS_Printf
   POP      EAX
   INT      Debug_Serv_Int
   JMP      Quit

 @@:
   iWin32   KeGetCurrentIrql
   CMP      EAX, 2
   JB       @f

   MOV      ESI, OFFSET IrqlAbove
   JMP      PrintQuit

 @@:
   PUSH     DS_EvaluateExpression
   POP      EAX
   INT      Debug_Serv_Int
   MOV      ESI, EBX  ;offset

   PUSH     DS_EvaluateExpression
   POP      EAX
   INT      Debug_Serv_Int


   SUB      EAX, EAX  ;Do not display PAGEIN XXX
   CALL     VerifyAddressRange
   INC      EDX
   JNE      @f
 NeedsIn:
   MOV      ESI, OFFSET NeedsPageIn
   JMP      PrintQuit

 @@:
   PUSH     EBX  ;size




   MOV      EDI, OFFSET xFileName

 
  NameLoop:
   PUSH     DS_GetCommandLineChar
   POP      EAX
   MOV      BL,1
   INT      Debug_Serv_Int

   CLD
   OR       AX,AX
   JE       NameFinished
   MOV      AH,0
   STOSW
   JMP      NameLoop

 NameFinished:
;   MOV      AL, 0
   STOSW


   POP      EBX ;SIZE

;   iWin32   DbgPrint, <OFFSET What>, ESI, EBX
;   ADD      ESP, 3*4
;   JMP      Quit
;   iWin32   KeEnterCriticalRegion

   iWin32  RtlInitUnicodeString, <OFFSET PUniStr>, <OFFSET FileName>
   ;vrati zero EAX

   ACCESS_MASK  equ 120116h ;FILE_GENERIC_WRITE OR DELETE OR FILE_APPEND_DATA
   FILE_ATTRIBUTES EQU EAX;FILE_ATTRIBUTE_NORMAL
   SHARE_ACCESS EQU EAX ;FILE_SHARE_NONE
   CREATE_DISPOSITION EQU 5;FILE_OVERWRITE_IF
   CREATE_OPTION EQU 850h;FILE_NON_DIRECTORY_FILE OR FILE_NO_INTERMEDIATE_BUFFERING

;   SUB     EAX, EAX
   LEA     ECX, Handle
   LEA     EDX, StatusBlock
   iWin32  ZwCreateFile, ECX, ACCESS_MASK, <OFFSET FileObj>, EDX, EAX,\
	                 FILE_ATTRIBUTES, SHARE_ACCESS,\
                         CREATE_DISPOSITION, CREATE_OPTION,\
	                 EAX, EAX
   TEST    EAX, EAX
   JNL     @f

   MOV      ESI, OFFSET CreateFailed
   JMP      PrintQuit


  @@:
   ;esi offset
   ;ebx size
   LEA     EDX, StatusBlock
   SUB     EAX, EAX
   iWin32  ZwWriteFile, Handle, EAX, EAX, EAX, EDX, ESI , EBX, EAX, EAX

 There:
   PUSH    EAX
   iWin32  ZwClose, Handle
   ;OR      EAX, EAX
   ;JNE     @@CloseFileFailed
   POP     EAX
   TEST    EAX, EAX
   JNL      @f

   MOV      ESI, OFFSET WriteFailed
   JMP      PrintQuit

  @@:

;   iWin32   KeLeaveCriticalRegion

 Quit:
;   MOV   ESP, OldStack
   POP   FS ;!!!!!!!!!!!!!
   POP   ES
   POP   DS
;   POPAD
   SUB   EAX, EAX
   RET
Xhandler ENDP

VerifyAddressRange:  ;ESI from EBX count
   OR    EBX, EBX
   JE    @FIN

   PUSH  ESI
   PUSH  EBX

   DEC   EBX
   MOV   CX, 0F000h
   ADD   EBX, ESI

   AND   BX, CX
   AND   SI, CX


  @@:
   PUSH  EAX
   iWin32 MmIsAddressValid, ESI
   OR    EAX, EAX
   POP   EAX 
   JNE   forward

   OR    EDX, -1

   OR    EAX, EAX   ;ukaz/neukaz
   JE    forward

   PUSH     ESI
   PUSH     DS_Printf
   MOV      PageAdr, ESI
   POP      EAX
   MOV      ESI, OFFSET PageIn
;  MOV      EDI, OFFSET InfoParameters
   INT      Debug_Serv_Int
   POP      ESI

  forward:
   ADD      ESI, 1000H
   CMP      EBX, ESI
   JAE      @b

   POP   EBX
   POP   ESI
  @FIN:
   RET

   
END DriverEntry

:TRANSLATE
@ECHO OFF
C:\BC5\BIN\BRC32.EXE -r XADIres.rc
CVTRES XADIres.res /MACHINE:IX86
C:\MASM32\BIN\ML /c /Cp /coff %0
LINK XADIext.obj XADIres.obj /OUT:XADIext.sys /SECTION:.rsrc,R /MERGE:.rdata=.text /DRIVER /align:0x20 /base:0x10000 /subsystem:native
DEL XADIres.res
DEL XADIres.obj
DEL XADIext.obj
