;@GOTO TRANSLATE


.686P

.MODEL            FLAT, STDCALL

   OPTION         CASEMAP: NONE

   INCLUDE        WINDOWS.inc
   UNICODE        = TRUE
   INCLUDE        APIMACRO.mac
   INCLUDE        NtStruc.inc
   INCLUDE        NTSTATUS.inc
   INCLUDE        NTDDK.inc

   ASSUME         FS: NOTHING

Space SEGMENT 'BSS'
BYTE (7000H-1000H) dup (?)  ;make offset as in kernel32.dll
Space ENDS

Code SEGMENT
ASSUME CS:Code
   ADVAPI32                     UNICODE_STRING <(LA32-1)*SIGN, LA32*SIGN, sA32>
   KERNEL32                     UNICODE_STRING <(LK32-1)*SIGN, LK32*SIGN, sK32>
   BaseAndResult                DWORD NULL
   Zero                         DWORD NULL
   serviceStatus                SERVICE_STATUS <>

   SE_LOAD_DRIVER_PRIVILEGE     EQU 10
   NewState                     LABEL  TOKEN_PRIVILEGES
                                DWORD  1
   dbLUID                       LUID_AND_ATTRIBUTES  <<SE_LOAD_DRIVER_PRIVILEGE, 0>, SE_PRIVILEGE_ENABLED>

   NtTerminateProcess           DWORD ?
   LdrLoadDll                   DWORD ?
   LdrGetDllHandle              DWORD ?

   RtlImageDirectoryEntryToData DWORD ?
   LdrProcessRelocationBlock    DWORD ?
   sprintf                      DWORD ?
   NtClose                      DWORD ?
   NtUnmapViewOfSection         DWORD ?
   NtAllocateVirtualMemory      DWORD ?
   NtOpenProcessToken           DWORD ?
   NtAdjustPrivilegesToken      DWORD ?

   OpenSCManagerW               DWORD ?
   OpenServiceW                 DWORD ?
   QueryServiceStatus           DWORD ?
   CloseServiceHandle           DWORD ? 
   CreateServiceW               DWORD ?
   StartServiceW                DWORD ? 
   DeleteService                DWORD ?
   ControlService               DWORD ?

   CreateFileW                  DWORD ?
   DeviceIoControl              DWORD ?
   _lwrite                      DWORD ?
   ExitProcess                  DWORD ?

   IoCreateDevice               DWORD ?
   IoDeleteDevice               DWORD ?
   IoCreateSymbolicLink         DWORD ?
   IoDeleteSymbolicLink         DWORD ?  
   IofCompleteRequest           DWORD ?


   _CR0                         DWORD ?
   _CR3                         DWORD ?
   BytesReturned                DWORD ?

   TEXTA    NTP, <NtTerminateProcess/0>
   TEXTA    LLD, <LdrLoadDll/0>
   TEXTA    LGD, <LdrGetDllHandle/0>
   TEXTA    RDE, <RtlImageDirectoryEntryToData/0>
   TEXTA    LRB, <LdrProcessRelocationBlock/0>
   TEXTA    SPR, <sprintf/0>
   TEXTA    NCL, <NtClose/0>
   TEXTA    NUV, <NtUnmapViewOfSection/0>
   TEXTA    NAV, <NtAllocateVirtualMemory/0>
   TEXTA    NOK, <NtOpenProcessToken/0>
   TEXTA    NAT, <NtAdjustPrivilegesToken/0>

   TEXT     A32, <ADVAPI32.dll/0>
   TEXTA    OSM, <OpenSCManagerW/0>
   TEXTA    OSV, <OpenServiceW/0>
   TEXTA    QSS, <QueryServiceStatus/0>
   TEXTA    CSH, <CloseServiceHandle/0>
   TEXTA    CSW, <CreateServiceW/0>
   TEXTA    SSV, <StartServiceW/0>
   TEXTA    DES, <DeleteService/0>
   TEXTA    CSV, <ControlService/0>

   TEXT     K32, <KERNEL32.dll/0>
   TEXTA    CFW, <CreateFileW/0>
   TEXTA    DIC, <DeviceIoControl/0>
   TEXTA    _LW, <_lwrite/0>
   TEXTA    EXP, <ExitProcess/0>

   TEXTA    ICD, <IoCreateDevice/0>
   TEXTA    IDD, <IoDeleteDevice/0>
   TEXTA    ICS, <IoCreateSymbolicLink/0>
   TEXTA    IDS, <IoDeleteSymbolicLink/0>
   TEXTA    ICR, <IofCompleteRequest/0>

   
LdrRelocateImage  PROC  USES EBX ESI EDI, NewBase
        MOV       EDI, NewBase
        MOV       EAX, [EDI+3CH]
        ADD       EAX, EDI
        MOV       ESI, [EAX+34H]
        LEA       EAX, NewBase
        sWin32    RtlImageDirectoryEntryToData, EDI, 1, IMAGE_DIRECTORY_ENTRY_BASERELOC, EAX
        TEST      EAX, EAX
        JE        Failed
        CMP       NewBase, 0
        JE        Failed
        MOV       EBX, EDI
        SUB       EBX, ESI
       @@:
        MOV       ECX, [EAX+4]
        LEA       EDX, [EAX+8]
        SUB       NewBase, ECX
        SUB       ECX, 8
        PUSH      EBX
        PUSH      EDX
        SHR       ECX,1
        PUSH      ECX
        MOV       ECX,EDI
        ADD       ECX,[EAX]
        PUSH      ECX
        sWin32    LdrProcessRelocationBlock
        TEST      EAX,EAX
        JE        Failed
        CMP       NewBase, 0
        JNE       @B
       Failed:
        RET
LdrRelocateImage  ENDP


xHandler:
    MOV      ECX, [ESP+12]
    MOV      EDX, [ESP+8]
    SUB      EAX, EAX
    MOV      (CONTEXT PTR [ECX]).regEip, NotFound
    MOV      (CONTEXT PTR [ECX]).regEsp, EDX
    RET


There:
   MOV      ESI, FS: TEB.pPEB
   ASSUME   ESI  :PTR PEB
   MOV      EAX, [ESI].pProcModules
   MOV      ECX, [ESI].MainImageBase
   MOV      EDI, [ESI].pProcParameters
   ASSUME   EDI  :PTR PROCESS_PARAMETERS
   ADD      EAX, PROCESS_MODULES.pFirstModEntry0
   MOV      EDX, [EAX]
   ASSUME   EDX  :PTR PEB_MODULE_ENTRY0
  @@:
   CMP      EAX, EDX
   JNE      NotEnd
   RET      ;fail by silent unhandled exception
  NotEnd:
   MOV      EBX, [EDX].ImageBase
   CMP      EBX, ECX
   JNE      Found
   LEA      EBP, [EDX].ImageBase
   MOV      EDX, [EDX].pNextModEntry0
   JMP      @B
  Found:
   ASSUME   EDX :NOTHING

   sWin32   FindFunc, EBX, sNTP
   TEST     EAX, EAX
   JNE      @F
   RET      ;fail by silent unhandled exception
  @@: 
   MOV      NtTerminateProcess, EAX  
   sWin32   FindFunc, EBX, sLLD
   MOV      LdrLoadDll, EAX
   sWin32   FindFunc, EBX, sLGD
   MOV      LdrGetDllHandle, EAX
   sWin32   FindFunc, EBX, sRDE
   MOV      RtlImageDirectoryEntryToData, EAX
   sWin32   FindFunc, EBX, sLRB
   MOV      LdrProcessRelocationBlock, EAX
   sWin32   FindFunc, EBX, sSPR
   MOV      sprintf, EAX
   sWin32   FindFunc, EBX, sNCL
   MOV      NtClose, EAX
   sWin32   FindFunc, EBX, sNUV
   MOV      NtUnmapViewOfSection, EAX
   sWin32   FindFunc, EBX, sNOK
   MOV      NtOpenProcessToken, EAX
   sWin32   FindFunc, EBX, sNAT
   MOV      NtAdjustPrivilegesToken, EAX
   sWin32   FindFunc, EBX, sNAV
   MOV      NtAllocateVirtualMemory, EAX
   LEA      ECX, [EBP+8] ;ImageSize
   sWin32   EAX, CurrentProcess, OFFSET BaseAndResult, 0,\
            ECX, MEM_COMMIT, PAGE_EXECUTE_READWRITE
   TEST     EAX, EAX
   JL       Terminate

   PUSHp    ESI, EDI
   MOV      EAX, OFFSET NewEIP
   MOV      ESI, [EBP]
   MOV      ECX, [EBP+8] ;ImageSize
   SUB      EAX, ESI
   MOV      EDI, BaseAndResult
   SHR      ECX, 2
   ADD      EAX, EDI
   MOV      EDX, EDI
   REP      MOVSD
   POPc     ESI, EDI
   JMP      EAX

  NewEIP:
   PUSH     EDX
   OR       DWORD PTR [EBP+14H], WAS_RELOCATED
   sWin32   LdrRelocateImage, EDX
   sWin32   NtUnmapViewOfSection, CurrentProcess, [EBP]
   POP      [EBP]  ;ImageBase

   PUSH     0
   sWin32   LdrLoadDll, [EDI].SearchPath.Buffer, OFFSET Zero, OFFSET ADVAPI32, ESP
   TEST     EAX, EAX
   POP      EBX
   JL       Terminate

   sWin32   FindFunc, EBX, sOSM
   MOV      OpenSCManagerW, EAX
   sWin32   FindFunc, EBX, sOSV
   MOV      OpenServiceW, EAX
   sWin32   FindFunc, EBX, sQSS
   MOV      QueryServiceStatus, EAX
   sWin32   FindFunc, EBX, sCSH
   MOV      CloseServiceHandle, EAX
   sWin32   FindFunc, EBX, sCSW
   MOV      CreateServiceW, EAX
   sWin32   FindFunc, EBX, sSSV
   MOV      StartServiceW, EAX
   sWin32   FindFunc, EBX, sDES
   MOV      DeleteService, EAX
   sWin32   FindFunc, EBX, sCSV
   MOV      ControlService, EAX

   PUSH     EAX   
   sWin32   LdrGetDllHandle, TRUE, 0, OFFSET KERNEL32, ESP
   TEST     EAX, EAX
   POP      EBX
   JL       Terminate

   sWin32   FindFunc, EBX, sCFW
   MOV      CreateFileW, EAX
   sWin32   FindFunc, EBX, sDIC
   MOV      DeviceIoControl, EAX
   sWin32   FindFunc, EBX, s_LW
   MOV      _lwrite, EAX
   sWin32   FindFunc, EBX, sEXP
   MOV      ExitProcess, EAX

   PUSH     ECX
   sWin32   NtOpenProcessToken, CurrentProcess, TOKEN_QUERY OR TOKEN_ADJUST_PRIVILEGES, ESP
   TEST     EAX, EAX
   POP      EBX
   JL       @F
   sWin32   NtAdjustPrivilegesToken, EBX, FALSE, OFFSET NewState, 0, NULL, NULL
   sWin32   NtClose, EBX
  @@:


   sWin32   GetService
   PUSH     EAX
   sWin32   CreateFileW, OFFSET DosDeviceName,\
                         GENERIC_READ OR GENERIC_WRITE,\
                         FILE_SHARE_READ OR FILE_SHARE_WRITE,\
                         NULL, OPEN_EXISTING, NULL, NULL
   MOV      EBX, EAX
   SUB      ESI, ESI
   sWin32   DeviceIoControl, EBX, _GetCR0, ESI, ESI, OFFSET _CR0, SIZEOF _CR0, OFFSET BytesReturned, ESI
   sWin32   DeviceIoControl, EBX, _GetCR3, ESI, ESI, OFFSET _CR3, SIZEOF _CR3, OFFSET BytesReturned, ESI
   sWin32   NtClose, EBX
   POP      EAX
   PUSH     EAX
   PUSH     EAX
   sWin32   ControlService, EAX, SERVICE_CONTROL_STOP, OFFSET serviceStatus
   sWin32   DeleteService
   sWin32   CloseServiceHandle
   cWin32   sprintf, sNTP, sCRX, _CR0, _CR3
   sWin32   _lwrite, STD_OUTPUT_HANDLE, sNTP, EAX
   sWin32   ExitProcess, EAX
  Terminate:
   sWin32   NtTerminateProcess, CurrentProcess, 0

   TEXT     DosDeviceName, <\\.\>
   TEXT     Bimodal, <Bimodal/0/0>

   SC_MANAGER_ALL_ACCESS  EQU STANDARD_RIGHTS_REQUIRED OR 03FH 
   SERVICE_ALL_ACCESS     EQU STANDARD_RIGHTS_REQUIRED OR 1FFH
   SERVICE_KERNEL_DRIVER  EQU 001H
   SERVICE_DEMAND_START   EQU 003H
   SERVICE_ERROR_NORMAL   EQU 001H

   SERVICE_CONTROL_STOP   EQU 001H
   SERVICE_RUNNING        EQU 004H

  GetService PROC USES ESI
    LOCAL    schSCManager: HANDLE
    SUB      ESI, ESI
    sWin32   OpenSCManagerW, ESI, ESI, SC_MANAGER_ALL_ACCESS
    MOV      schSCManager, EAX
    TEST     EAX, EAX
    JE       ErrorOpenSCManager
    sWin32   OpenServiceW, schSCManager, OFFSET Bimodal, SERVICE_ALL_ACCESS
    TEST     EAX, EAX
    JE       CreateService
    PUSH     EAX
    sWin32   QueryServiceStatus, EAX, OFFSET serviceStatus
    POP      EAX
    CMP      serviceStatus.dwCurrentState, SERVICE_RUNNING
    JE       CloseAll
    PUSH     EAX
    PUSH     EAX
    sWin32   ControlService, EAX, SERVICE_CONTROL_STOP, OFFSET serviceStatus
    sWin32   DeleteService
    sWin32   CloseServiceHandle

   CreateService:
    sWin32   CreateServiceW, schSCManager, OFFSET Bimodal, OFFSET Bimodal,\
                             SERVICE_ALL_ACCESS, SERVICE_KERNEL_DRIVER,\
                             SERVICE_DEMAND_START, SERVICE_ERROR_NORMAL,\
                             (PROCESS_PARAMETERS PTR [EDI]).ImagePath.Buffer, ESI, ESI, ESI, ESI, ESI
   StartService:
    PUSH     EAX
    sWin32   StartServiceW, EAX, ESI, ESI
    POP      EAX
   CloseAll:
    PUSH     EAX
    sWin32   CloseServiceHandle, schSCManager
    POP      EAX
   ErrorOpenSCManager:
    RET
  GetService ENDP






  Unload        PROC  ;DriverObject
     sWin32     IoDeleteSymbolicLink, OFFSET SymLinkNameUnicode
     MOV	EAX,  [ESP+4] ;DriverObject
     sWin32     IoDeleteDevice , (DRIVER_OBJECT PTR [EAX])._PDEVICE_OBJECT
     SUB        EAX, EAX  
     RET        4
  Unload	ENDP

     ALIGN 4
     BimodalServices DWORD GetCR0, GetCR3
     MaxService = LENGTHOF BimodalServices SHL 2

     DevNameUnicode     UNICODE_STRING <(LBimodalKM-1)*SIGN, LBimodalKM*SIGN, sBimodalKM>
     SymLinkNameUnicode UNICODE_STRING <(LDosBimoKM-1)*SIGN, LDosBimoKM*SIGN, sDosBimoKM>
     TEXTW       BimodalKM, <\Device\Bimodal/0>
     TEXTW       DosBimoKM, <\DosDevices\Bimodal/0>

  DriverEntry   PROC USES EBX ESI EDI , DriverObject, RegPath 
     LOCAL      DeviceObject      :DWORD

     MOV	ESI,  DriverObject 
     ASSUME     ESI:  PTR DRIVER_OBJECT

     MOV        EBX, [ESI].PDISPATCH_IRP_MJ_CREATE
     AND        EBX, 0FFF00000H

     MOV        EAX,  OFFSET StandardDispatch
     MOV        [ESI].PDRIVER_UNLOAD,                  OFFSET Unload 
     MOV        [ESI].PDISPATCH_IRP_MJ_CREATE,         EAX  
     MOV        [ESI].PDISPATCH_IRP_MJ_CLOSE,          EAX  
     MOV        [ESI].PDISPATCH_IRP_MJ_DEVICE_CONTROL, OFFSET Dispatch 


   sWin32   FindFunc, EBX, sICD
   TEST     EAX, EAX
   JNE      @F
   MOV      EAX, STATUS_UNSUCCESSFUL
   JMP      CreateDeviceFailed
  @@: 
   MOV      IoCreateDevice, EAX
   sWin32   FindFunc, EBX, sIDD
   MOV      IoDeleteDevice, EAX
   sWin32   FindFunc, EBX, sICS
   MOV      IoCreateSymbolicLink, EAX
   sWin32   FindFunc, EBX, sIDS
   MOV      IoDeleteSymbolicLink, EAX
   sWin32   FindFunc, EBX, sICR
   MOV      IofCompleteRequest, EAX

     oLEA       EDI,  DevNameUnicode
     SUB        EAX,  EAX
     LEA        ECX,  DeviceObject
     ExtensionSize      EQU EAX ;0
     DevType	        EQU 22H ;FILE_DEVICE_UNKNOWN
     DevCharacteristic  EQU EAX ;0
     Exclusive	        EQU EAX ;FALSE
     sWin32     IoCreateDevice, ESI, ExtensionSize, EDI, DevType,\
	                        DevCharacteristic, Exclusive, ECX
     TEST       EAX,  EAX
     JL         CreateDeviceFailed

     MOV        EDX,  DeviceObject
     OR         (DEVICE_OBJECT PTR [EDX]).FLAGS, DO_BUFFERED_IO
   

     sWin32     IoCreateSymbolicLink, OFFSET SymLinkNameUnicode, EDI
     TEST       EAX,  EAX
     JGE        SymLinkCreated

     PUSH       EAX 
     sWin32     IoDeleteDevice , DeviceObject
     POP        EAX
 
    SymLinkCreated:
    CreateDeviceFailed:
     RET        
  DriverEntry   ENDP

  Dispatch      PROC  ;USES EBX EBP ESI EDI,  DeviceObject, pIRP

     MOV	ECX,  [ESP+4+4] ;pIRP
     ASSUME     ECX:  PTR _IRP
     PUSH       EBX
     PUSH       EBP
     PUSH       ESI
     PUSH       EDI

     MOV	EDI,  [ECX].PCurrentIrpStackLocation
     MOV	ESI,  [ECX].SystemBuffer
     ASSUME     EDI:  PTR IO_STACK_LOCATION
     MOV        EAX,  [EDI].DeviceIoControl.IoControlCode
     MOV        EDX,  [EDI].DeviceIoControl.OutputBufferLength

     PUSH       ECX   

     ICCMask    = 222000H
     XOR	EAX,  ICCMask
     CMP        EAX,  MaxService
     JAE        ItsBad

     TEST       AL,   11B
     JE         @F    

    ItsBad:
     MOV        EAX,  STATUS_NOT_IMPLEMENTED
     SUB        EDX,  EDX
     JMP        QuitDispatch

    @@:
     CALL       BimodalServices[EAX]

    QuitDispatch:
     POP        ECX
     POP        EDI
     POP        ESI
     POP        EBP
     POP        EBX

   QuitDisp::
     PUSH       EAX
     MOV        [ECX].IoStatus.Information, EDX
     MOV        [ECX].IoStatus.Status, EAX 
     SUB        EDX, EDX
     sWin32     IofCompleteRequest
     POP        EAX
     RET        8
  Dispatch      ENDP


  StandardDispatch  PROC ;DeviceObject, pIRP
     SUB        EAX, EAX
     MOV        ECX, [ESP+4+4] ;pIRP
     MOV        EDX, EAX
     JMP        QuitDisp
  StandardDispatch  ENDP

;---------------------------------------------------------------------------------------
   BYTE     (8C1H-($-Code)) DUP ('E')  ;reserve space  so BaseProcessST == 77E878C1H


  BaseProcessStartThunk:  ;!!!!!!!!!! set it to your KERNEL32 thunk offset !!!!!
   JMP      There
;---------------------------------------------------------------------------------------

ASSUME ESI: NOTHING
  SmallBuffer:
   MOV      EAX, STATUS_BUFFER_TOO_SMALL
   SUB      EDX, EDX
   RET

  GetCR0:
   MOV      EAX, CR0
   JMP      @F

  GetCR3:
   MOV      EAX, CR3
  @@:
   CMP      EDX, DWORD
   JB       SmallBuffer
   oMOV     EDX, DWORD
   MOV      [ESI], EAX
   SUB      EAX, EAX
   RET

   _GetCR0  = ICCMask + 0
   _GetCR3  = ICCMask + 4
   TEXTA    CRX, <CR0 = 0x/#.8X, CR3 = 0x/#.8X/n/0>

ASSUME EDI:NOTHING

ASSUME ECX:NOTHING
FindFunc PROC USES EBX ESI EDI EBP, Base, Func
               SUB    EAX, EAX  
               PUSH   xHandler
               PUSH   FS:[EAX]
               MOV    FS:[EAX], ESP

               MOV    EBX, Base
               MOV    EBP, Func
               MOV    EDX, [EBX+3CH]        ;PE header start
               MOV    EDX, [EDX+78H+EBX]    ;export table
               TEST   EDX, EDX
              @@:
               JE     NotFound
               ADD    EDX, EBX
               CMP    EBP, 10000H   ;ordinal# or name?
               JAE    @F
               XCHG   EAX, EBP           ;eax = ordinal#
               SUB    EAX, [EDX+10H]     ;eax = ordinal# - ordinal base
               JMP    ExportOrd
              @@:
             ;search for the name of wanted api
               PUSH   EBX
               PUSH   ESI
               PUSH   EDI
               MOV    ECX, [EDX+18H] ;amountofnames
               MOV    ESI, [EDX+20H] ;addressofnames
               ADD    ESI, EBX
               PUSH   EDX
              @@:
               JECXZ  NameSearchFinished  ;nothing left to explore
               LODSD
               SUB    EDI, EDI
               ASSUME EDI: PTR BYTE
               ADD    EAX, EBX
               DEC    ECX
              NextChar:
               MOV    DL,  [EAX+EDI]     ;find matching API name
               CMP    DL,  [EBP+EDI]     ;by comparing letters
               JNE    @B                 ;no match go next name
               INC    EDI
               TEST   DL,  DL
               JNE    NextChar           ;repeat until NULL character
               SUB    EAX, EAX           ;api found! -> EAX = NULL
              NameSearchFinished:
               POP    EDX
               POP    EDI
               ASSUME EDI: PTR DWORD
               POP    ESI
               POP    EBX

               TEST   EAX, EAX
               JNE    NotFound

               SUB    ECX, [EDX+18H]     ;amountofnames
               MOV    EAX, [EDX+24H]     ;ordinals for names
               INC    ECX
               NEG    ECX
               ADD    EAX, EBX
               MOVZX  EAX, WORD PTR [ECX*2+EAX]
             ExportOrd:
               MOV    ECX, EBX           ;ecx = module base
               ADD    ECX, [EDX+1CH]
               MOV    EAX, [ECX+EAX*4]   ;orig address
               ADD    EAX, EBX
               JMP    Ret0
             NotFound::
               SUB    EAX, EAX
             Ret0:
               POP    FS:0
               POP    ECX
               RET
FindFunc ENDP



Code ENDS

END DriverEntry

:TRANSLATE
@ECHO OFF
ML    /c /coff /nologo bimodal.bat
eLINK bimodal  /nologo /BASE:0X77E80000 /SUBSYSTEM:CONSOLE /FIXED:NO
eLINK -EDIT /RELEASE /nologo /SECTION:Code,cewr!p /SECTION:Space,p /SECTION:.reloc,p bimodal.exe
DEL   bimodal.obj
PAUSE
CLS