;@goto translate
;===============================================================================


;It detects (June 1999), for example, ProcDump and TRW when tracing



.586P
.MODEL FLAT,  STDCALL

 OPTION       CASEMAP :NONE

 
 INCLUDE      KERNEL32.INC
 INCLUDE      USER32.INC

 INCLUDELIB   KERNEL32.LIB
 INCLUDELIB   USER32.LIB


 UNICODE      = 0
 ARGUMENTS    = 0
 INCLUDE      W32MAIN.INC


;===============================================================================
.DATA
    xText     BYTE  "Tracing (simple)",0
    Traced    BYTE  "Detected.",0
    NotTraced BYTE  "Not detected.",0

;===============================================================================
.CODE

 Start:

    PUSHFD
    POP       EAX                   ;EAX = EFlags

    TEST      AH, 1                 ;Am I traced?  == Is Trap Flag set?
    JNE       Detected              ;In DOS world, it is called 
                                    ;"real_mode_tracer detection"

    ;above is 7 bytes, 4 instructions and 0 API calls


    ;Solution for tracer:
    ;1) helpEIP := victimEIP + size_of_prefixes    ;skip prefixes
    ;   2a) IF [helpEIP] = PUSHFD  THEN  Emulate  ELSE  go_on_normally
    ;or 2b) IF I_am_tracing  THEN  Emulate  ELSE  go_on_normally
    ;       -that's the way how SoftICE does it

    ;Emulate: victimESP   := victimESP - size_of_EFlags
    ;         victimEIP   := helpEIP + size_of_pushfd_opcode
    ;         [victimESP] := victimEFlags AND NOT 100H    ;"clear Trap Flag"
    ;         go victimEIP


    INVOKE    MessageBox, NULL, ADDR NotTraced, ADDR xText, MB_ICONINFORMATION
    JMP       @f

   Detected:
    INVOKE    MessageBox, NULL, ADDR Traced, ADDR xText, MB_ICONEXCLAMATION

   @@:
    INVOKE    ExitProcess, 0



END Start

:translate
@echo off
ML /nologo /c /coff DetectTracerSimple.bat
LINK DetectTracerSimple.obj /nologo /SUBSYSTEM:WINDOWS /RELEASE /ALIGN:0X1000 /MERGE:.rdata=.text /MERGE:.data=.text /MERGE:.text=Detect /SECTION:Detect,RWE  /IGNORE:4078,4108
DEL DetectTracerSimple.obj
