;@GOTO TRANSLATE

COMMENT $

This KDext was never tested with WinDbg but with SoftICE
convert it via KD2SYSXLAT or KD2SYS, reboot and in SoftICE type:
!?
$

.586P
.MODEL FLAT, STDCALL

 OPTION     CASEMAP: NONE

 ARGUMENTS  = 0              
 UNICODE    = 0              
 INCLUDE    W32Main.inc     ;get the updated .inc on my www

 INCLUDE    wdbgexts.inc

 INCLUDELIB C:\98DDK\LIB\I386\FREE\NTDLL.lib
 iscntrl PROTO C :DWORD
 isspace PROTO C :DWORD

;===============================================================================
.DATA

 KDextSimpleVersion EXT_API_VERSION <EXT_API_VERSION_NUMBER, 0, 5, 0>


 Inside         LABEL  CHAR
                STRING <Inside /#s ../l/0>
 WDEDllInit     LABEL  CHAR
                STRING <WinDbgExtensionDllInit/0>
 EAVersion      LABEL  CHAR
                STRING <ExtensionApiVersion/0>
 ChkVersion     LABEL  CHAR
                STRING <CheckVersion/0>

 PureString     LABEL  CHAR
                STRING </#s/l/0>
 ErrorBadArg    LABEL  CHAR
                STRING <ERROR: Bad CPU number/0>
 ThreadHelp     LABEL  CHAR
                STRING </:tinfo [processor | -? | -h]/ldisplays CS:EIP,DRx of current thread/0>
 TSCHelp        LABEL  CHAR
                STRING </:gettsc [-? | -h]/ldisplays time stamp counter/0>
 SimpleExt      LABEL  CHAR
                STRING <Simple sample KD extension/l>
                STRING <--------------------------/0>


 ThreadInfoTemplate LABEL  CHAR 
                STRING <CS:EIP=/#04X:/#08X/lDR0=/#08X/lDR1=/#08X>
                STRING </lDR2=/#08X/lDR3=/#08X/lDR6=/#08X/lDR7=/#08X/l/0>


 TSCTemplate    LABEL  CHAR
                STRING <TSC=/#08X/#08X/l/0>



 BadEnvTemplate LABEL  CHAR
                STRING <*** Extension DLL(/#d Free) does not match target >
                STRING <system(/#d /#s)/l/0>
 BuildFree      LABEL  CHAR
                STRING <Free/0>
 BuildChecked   LABEL  CHAR
                STRING <Checked/0>

 ;my fantasy.....
 MSRstruct            STRUCT 
  _ECX                DWORD  ?
  unknownDD           DWORD  ?
  _EDX                DWORD  ?
  _EAX                DWORD  ?
 MSRstruct            ENDS 

 TSC                  MSRstruct  <16, 0, ?, ?>
 
.DATA?

 WinDbgExtApis        WINDBG_EXTENSION_APIS {}
 CurrentMajorVersion  DWORD ?
 CurrentMinorVersion  DWORD ?

;===============================================================================
.CODE

 PUBLIC    WinDbgExtensionDllInit, ExtensionApiVersion, CheckVersion,\
           tinfo, gettsc, help
;===============================================================================
;following function must be exported, returns nothing
WinDbgExtensionDllInit  PROC  USES ESI EDI, 
                              lpExtensionApis,\
                              MajorVersion :USHORT,\
                              MinorVersion :USHORT

        MOVZX   EAX,    MajorVersion 
        MOVZX   ECX,    MinorVersion 
        MOV     CurrentMajorVersion, EAX
        MOV     CurrentMinorVersion, ECX
        ;CLD    ensured by kd (should be)
        PUSH    SIZEOF  WINDBG_EXTENSION_APIS / 4
        MOV     ESI,    lpExtensionApis
        MOV     EDI,    OFFSET WinDbgExtApis
        POP     ECX
        REP     MOVSD
        cWin32  WinDbgExtApis.lpOutputRoutine, <OFFSET Inside>,\
                                               <OFFSET WDEDllInit>
	RET
WinDbgExtensionDllInit  ENDP
;===============================================================================
;following function must be exported, returns pointer to EXT_API_VERSION
ExtensionApiVersion     PROC  
        cWin32  WinDbgExtApis.lpOutputRoutine, <OFFSET Inside>,\
                                               <OFFSET EAVersion>
        MOV	EAX,	OFFSET KDextSimpleVersion
	RET
ExtensionApiVersion     ENDP
;===============================================================================
;following function can be exported, it returns BOOL (probably)
CheckVersion            PROC
        cWin32  WinDbgExtApis.lpOutputRoutine, <OFFSET Inside>,\
                                               <OFFSET ChkVersion>
        MOV     EAX,    CurrentMajorVersion
        MOV     ECX,    CurrentMinorVersion
        MOV     EDX,    OFFSET  BuildChecked
        FreeBuild       = 15
        CMP     EAX,    FreeBuild
        JNE     BadEnvironment
        BuildNo         = 1381
        CMP     ECX,    BuildNo
        MOV     EDX,    OFFSET  BuildFree
        JE      @f
       BadEnvironment:
        cWin32  WinDbgExtApis.lpOutputRoutine, <OFFSET BadEnvTemplate>,\
                                               BuildNo, ECX, EDX
       @@:
	RET
CheckVersion            ENDP
;===============================================================================
;this function has de facto no sense
tinfo                   PROC   USES  EBX ESI EDI,
                               hCurrentProcess,\
                               hCurrentThread,\
                               dwCurrentPc,\
                               dwProcessor,\
                               args

;nice arguments, but in SoftICE:
;  hCurrentProcess = 0
;  hCurrentThread  = 0   ;in context are cx_DRx always 0
;  dwCurrentPc     = EIP
;  dwProcessor     = CPU No
;  args            = CmdLine



        LOCAL   context       :CONTEXT
        LOCAL   ppi           :PROCESSORINFO

        MOV     ESI, args

       @@:
        LODSB
        MOVZX   EBX, AL

;        INVOKE  iscntrl, EBX            ;NTice doesn't export for now
;        TEST    EAX, EAX
        TEST     AL,  AL
;        JNE     WorkWithCurrentProcessor
        JE      WorkWithCurrentProcessor

        INVOKE  isspace, EBX
        TEST    EAX, EAX
        JNE      @b

        CMP      BL, '-'
        JNE      @f 
        LODSB
        MOV     EDX, OFFSET ThreadHelp
        CMP      AL, '?'
        JE      Output
        CMP      AL, 'h'
        JE      Output

      GetNumError:
        MOV     EDX, OFFSET ErrorBadArg
      Output:
        cWin32  WinDbgExtApis.lpOutputRoutine, <OFFSET PureString>, EDX
        JMP     tfin

       @@:
        DEC     ESI
        CALL    GetNumParameter
        TEST    EDI, EDI
        JE      GetNumError


        ;standard way of getting NumberProcessors is:
        ;byte NumCPU = 0;
        ;void *address;
        ;dword BytesRead = 0;
        ;address = lpGetExpressionRoutine("NT!KeNumberProcessors");
        ;lpReadProcessMemoryRoutine(address, NumCPU, 1, &BytesRead);
        ;and NumCPU contains number of processors

        ;I'm not sure if processor No. has sense in this function

        LEA     EAX, ppi 
        sWin32  WinDbgExtApis.lpIoctlRoutine, IG_KD_CONTEXT, EAX, SIZEOF ppi
        TEST    EAX, EAX
        JE      tfin 
        CMP      BX, ppi.NumberProcessors
        JAE     GetNumError 
        JMP     @f

       WorkWithCurrentProcessor:
        MOV     EBX, dwProcessor
       @@:
        LEA     ESI, context 
        ASSUME  ESI: PTR CONTEXT
        sWin32  WinDbgExtApis.lpGetThreadContextRoutine, EBX, ESI,\
                                                         SIZEOF context
        TEST    EAX, EAX
        JE      tfin 
        cWin32  WinDbgExtApis.lpOutputRoutine, <OFFSET ThreadInfoTemplate>,\
                                               [ESI].cx_SegCs, [ESI].cx_Eip,\
                                               [ESI].cx_Dr0, [ESI].cx_Dr1,\
                                               [ESI].cx_Dr2, [ESI].cx_Dr3,\
                                               [ESI].cx_Dr6, [ESI].cx_Dr7
      tfin:
        RET
tinfo                    ENDP
;===============================================================================
gettsc                   PROC  USES  EBX,
                               hCurrentProcess,\
                               hCurrentThread,\
                               dwCurrentPc,\
                               dwProcessor,\
                               args

        MOV     ESI, args
       @@:
        LODSB
        MOVZX   EBX, AL

;        INVOKE  iscntrl, EBX   
;        TEST    EAX, EAX
        TEST     AL,  AL
;        JNE     WorkNormal
        JE      WorkNormal

        INVOKE  isspace, EBX
        TEST    EAX, EAX
        JNE      @b

        CMP      BL, '-'
        JNE      WorkNormal
        LODSB
        CMP      AL, '?'
        JE      Output
        CMP      AL, 'h'
        JNE     WorkNormal
       Output:
        cWin32  WinDbgExtApis.lpOutputRoutine, <OFFSET PureString>,\
                                               <OFFSET TSCHelp>
        JMP     @f
 
       WorkNormal:
        MOV     EBX,  OFFSET TSC
        ASSUME  EBX:  PTR MSRstruct
        sWin32  WinDbgExtApis.lpIoctlRoutine, IG_READ_MSR, EBX, SIZEOF TSC
        TEST    EAX, EAX
        JE      @f
        cWin32  WinDbgExtApis.lpOutputRoutine, <OFFSET TSCTemplate>,\
                                               [EBX]._EDX, [EBX]._EAX
       @@:
        RET
gettsc                   ENDP
;===============================================================================
;this is invoked when !? or !help
help                     PROC  USES  EBX,
                               hCurrentProcess,\
                               hCurrentThread,\
                               dwCurrentPc,\
                               dwProcessor,\
                               args
        MOV     EBX, OFFSET PureString 
        cWin32  WinDbgExtApis.lpOutputRoutine, EBX, <OFFSET SimpleExt>
        cWin32  WinDbgExtApis.lpOutputRoutine, EBX, <OFFSET ThreadHelp>
        cWin32  WinDbgExtApis.lpOutputRoutine, EBX, <OFFSET TSCHelp>
        RET
help                     ENDP
;===============================================================================
GetNumParameter          PROC
        SUB     EDI,  EDI
        SUB     EBX,  EBX

       Repete:
        CMP     EDI,   8
        JA      GetNumErr
        LODSB
        MOVZX   EAX,  AL

;        PUSH    EAX
;        INVOKE  iscntrl, EAX
;        TEST     EAX, EAX
        TEST     AL, AL
;        POP     EAX 
;        JNE     GetNumEnd
        JE     GetNumEnd

        PUSH    EAX
        INVOKE  isspace, EAX
        TEST    EAX, EAX
        POP     EAX
        JNE     GetNumEnd

        SUB      AL, '0'
        CMP      AL,   9
        JBE      @f
        SUB      AL,   7
        CMP      AL,  16
        JAE      GetNumErr
      @@:
        SHL     EBX,   4
        INC     EDI
        OR       BL,  AL
        JMP     Repete
      GetNumErr:
        SUB     EDI, EDI
       GetNumEnd:
        RET
GetNumParameter          ENDP


END

:TRANSLATE
@ECHO OFF
ML /nologo /c /coff EliKDX.bat
LINK EliKDX /nologo /RELEASE /DEBUG /SUBSYSTEM:NATIVE /VERSION:4.0 /NOENTRY /BASE:0X456C0000 /DLL /ALIGN:0X1000  /DEF:EliKDX.def /MERGE:.rdata=.text /MERGE:.edata=.text /MERGE:.data=.text /MERGE:.text=EliKDX /SECTION:EliKDX,EWR /IGNORE:4078,4108
DEL EliKDX.exp
DEL EliKDX.lib
DEL EliKDX.obj
DEL EliKDX.pdb