
;-----------------------------------------
     CLIENT_ID         STRUCT     ;NTDDK
      UniqueProcess    DWORD ?
      UniqueThread     DWORD ?
     CLIENT_ID         ENDS
;-----------------------------------------
     OBJECT_ATTRIBUTES STRUCT          ;NTDDK
      Length_          DWORD ?
      RootDirectory    DWORD ?
      ObjectName       DWORD ?
      Attributes       DWORD ?
      SecurityDescriptor DWORD ?
      SecurityQualityOfService DWORD ?
     OBJECT_ATTRIBUTES ENDS
;-----------------------------------------
     TIME_FIELDS      STRUC DWORD       ;NTDDK
      Year            WORD  ?   ;range [1601...]
      Month           WORD  ?   ;range [1..12]
      Day             WORD  ?   ;range [1..31]
      Hour            WORD  ?   ;range [0..23]
      Minute          WORD  ?   ;range [0..59]
      Second          WORD  ?   ;range [0..59]
      Milliseconds    WORD  ?   ;range [0..999]
      Weekday         WORD  ?   ;range [0..6] == [Sunday..Saturday]
     TIME_FIELDS      ENDS
;-----------------------------------------
     ELAPSED_TIME_FIELDS    STRUCT DWORD  ;EliCZ
      Years           WORD  ?   ;RtlTTETF sets to 0
      Months          WORD  ?   ;RtlTTETF sets to 0
      Days            WORD  ?
      Hours           WORD  ?
      Minutes         WORD  ?
      Seconds         WORD  ?
      Milliseconds    WORD  ?
     ELAPSED_TIME_FIELDS    ENDS
;-----------------------------------------
   CurrentThread      EQU -2          ;in both 9x and NT
   CurrentProcess     EQU -1          ;in NT
;-----------------------------------------
     LPWSTR   TYPEDEF  DWORD

     UNICODE_STRING    STRUCT          ;NTDDK
      Length_          USHORT ?
      MaximumLength    USHORT ?
      Buffer           LPWSTR ?
     UNICODE_STRING    ENDS
;-----------------------------------------
 ;usually: ModEntry0 + 8 == ModEntry2 and ModEntry2 + 8 == DllEntry
 ;         ModEntry1 + 8 == ModEntry3 and ModEntry3 + 8 == ModEntry4

     PROCESS_MODULES    STRUCT      ;EliCZ
      cbsize            DWORD ?  ;00 == 24H
      Unknown4          DWORD ?  ;04
      Unknown8          DWORD ?  ;08
      pFirstModEntry0   DWORD ?  ;0C
      pFirstModEntry1   DWORD ?  ;10
      pFirstModEntry2   DWORD ?  ;14
      pFirstModEntry3   DWORD ?  ;18
      pFirstDllEntry    DWORD ?  ;1C
      pFirstModEntry4   DWORD ?  ;20
     PROCESS_MODULES    ENDS
;-----------------------------------------
       UPDATE_LOAD_COUNT             EQU 00000004H  ;?????
       LOAD_IN_PROGRESS              EQU 00001000H  ;?????
       HAS_DLLMAIN_OR_IS_INITIALIZED EQU 00004000H  ;?????
       ALLOW_DLL_PROCESS_DETACH      EQU 00080000H  ;?????
       WAS_RELOCATED                 EQU 00200000H  ;?????

     PEB_MODULE_ENTRY0 STRUCT          ;EliCZ
      pNextModEntry0   DWORD ?  ;00
      pNextModEntry1   DWORD ?  ;04
      pNextModEntry2   DWORD ?  ;08
      pNextModEntry3   DWORD ?  ;0C
      pNextDllEntry    DWORD ?  ;10
      pNextModEntry4   DWORD ?  ;14
      ImageBase        DWORD ?  ;18
      ImageEntry       DWORD ?  ;1C
      ImageSize        DWORD ?  ;20
      ModuleFileName   UNICODE_STRING <>  ;24
      ModuleBaseName   UNICODE_STRING <>  ;2C
      dwFlags          DWORD ?  ;34
      RefCount          WORD ?  ;38
      TlsCallbacks      WORD ?  ;3A
      pTEBarea0        DWORD ?  ;3C
      pTEBarea1        DWORD ?  ;40
      ImageTimeStamp   DWORD ?  ;44
     PEB_MODULE_ENTRY0 ENDS
;-----------------------------------------
     PEB_DLL_ENTRY     STRUCT          ;EliCZ
      pNextDllEntry    DWORD ?  ;00
      pNextModEntry4   DWORD ?  ;04
      ImageBase        DWORD ?  ;08
      ImageEntry       DWORD ?  ;0C
      ImageSize        DWORD ?  ;10
      ModuleFileName   UNICODE_STRING <>  ;14
      ModuleBaseName   UNICODE_STRING <>  ;1C
      dwFlags          DWORD ?  ;24
      RefCount          WORD ?  ;28
      TlsCallbacks      WORD ?  ;2A
      pTIBarea0        DWORD ?  ;3C
      pTIBarea1        DWORD ?  ;40
      ImageTimeStamp   DWORD ?  ;34
     PEB_DLL_ENTRY     ENDS
;-----------------------------------------
      ;Flags:
      PROCESS_PARAMETERS_NORMALIZED = 1 ;pointers in structure are absolute
      ;if PP is denormalized, pointers are self-relative

;  let's say PROCESS_PARAMETERS contains ENVIRONMENT_INFORMATION
     PROCESS_PARAMETERS STRUCT         ;EliCZ
      cbsize            DWORD ?  ;00 == 1000H
      Unknown04         DWORD ?  ;04
      Flags             DWORD ?  ;08
      Unknown0C         DWORD ?  ;0C
      CsrConsoleInfo    DWORD ?  ;10  for Csr calls
      Unknown14         DWORD ?  ;14
      StdInputHandle    DWORD ?  ;18
      StdOutputHandle   DWORD ?  ;1C
      StdErrorHandle    DWORD ?  ;20
      CurrentDirectory  UNICODE_STRING <>  ;24
      DirectoryFlags    DWORD ?  ;2C   == 18H
      SearchPath        UNICODE_STRING <>  ;30
      ImagePath         UNICODE_STRING <>  ;38
      CommandLine       UNICODE_STRING <>  ;40
      Environment       DWORD ?  ;48
      Unknown4C         DWORD ?  ;4C
      Unknown50         DWORD ?  ;50
      Unknown54         DWORD ?  ;54
      Unknown58         DWORD ?  ;58
      Unknown5C         DWORD ?  ;5C
      Unknown60         DWORD ?  ;60
      Unknown64         DWORD ?  ;64
      Unknown68         DWORD ?  ;68
      Unknown6C         DWORD ?  ;6C
      ImagePath2        UNICODE_STRING <>  ;70
      WinStation        UNICODE_STRING <>  ;78
      CommandLine2      UNICODE_STRING <>  ;80  ??
      ;etc...
     PROCESS_PARAMETERS ENDS
;-----------------------------------------
   ;dwFlags:
     DEBUGGER_PRESENT = 10000H

     PEB              STRUCT           ;EliCZ
      dwFlags         DWORD ?  ;00  ;or word only?
      Unknown04       DWORD ?  ;04  == -1
      MainImageBase   DWORD ?  ;08
      pProcModules    DWORD ?  ;0C  == *PROCESS_MODULES
      pProcParameters DWORD ?  ;10  == *PROCESS_PARAMETERS
      Unknown14       DWORD ?  ;14  == 0
      ProgramHeap     DWORD ?  ;18
      LockingContext  DWORD ?  ;1C  == FastPebLock
      LockRoutine     DWORD ?  ;20  == RtlEnterCriticalSection
      UnlockRoutine   DWORD ?  ;24  == RtlLeaveCriticalSection
      DirChange       DWORD ?  ;28  == 1
      Unknown2C       DWORD ?  ;2C  == apfnDispatch
      Unknown30       DWORD ?  ;30  == 0
      Unknown34       DWORD ?  ;34  == 0
      Unknown38       DWORD ?  ;38  == 0
      Unknown3C       DWORD ?  ;3C  == 0
      Unknown40       DWORD ?  ;40  == TlsBitMap
      Unknown44       DWORD ?  ;44  == 3FH
      Unknown48       DWORD ?  ;48  == 0
      ProgramHeap02   DWORD ?  ;4C
      ProgramHeap02a  DWORD ?  ;50
      InProgramHeap02 DWORD ?  ;54
      AnsiCodePage    DWORD ?  ;58
      OemCodePage     DWORD ?  ;5C
      UnicodeCodePage DWORD ?  ;60
      NumberProcessors DWORD ?  ;64
      GlobalFlag      DWORD ?  ;68
      Unknown6C       DWORD ?  ;6C  == 0
      CritSectTimeout DWORD ?  ;70
      Unknown74       DWORD ?  ;74
      HeapSegmentReserve  DWORD ?  ;78
      HeapSegementCommit  DWORD ?  ;7C
      HeapDeCommitTotalFreeTreshold DWORD ?  ;80  == 10000H
      HeapDeCommitFreeBlockTreshold DWORD ?  ;84  == 1000H
      Unknown88       DWORD ?  ;88
      Unknown8C       DWORD ?  ;8C  == 386H
      Unknown90       DWORD ?  ;90  == RtlpProcessHeapsListBuffer
      Unknown94       DWORD ?  ;94
      Unknown98       DWORD ?  ;98  == 0
      Unknown9C       DWORD ?  ;9C  == 14H
      UnknownA0       DWORD ?  ;A0  == LoaderLock
      dwMajorVersion  DWORD ?  ;A4
      dwMinorVersion  DWORD ?  ;A8
      dwBuildNumber    WORD ?  ;AC
      CSDVersion       WORD ?  ;AE
      dwPlatformId    DWORD ?  ;B0
      Subsystem       DWORD ?  ;B4
      MajorSusbsytemVersion  DWORD ?  ;B8
      MinorSusbsytemVersion  DWORD ?  ;BC
      ProcessAffinityMask    DWORD ?  ;C0
      UnknownC4       DWORD  044H DUP (?) ;C4
      SessionId       DWORD ?  ;1D4
      ;.....
     PEB              ENDS
;-----------------------------------------
     TEB              STRUCT           ;NTDDK + EliCZ
      ExceptionList   DWORD ?            ;00
      StackBase       DWORD ?            ;04
      StackLimit      DWORD ?            ;08
      SubSystemTib    DWORD ?            ;0C
      UNION
       FiberData      DWORD ?            ;10
       Version        DWORD ?            ;10
      ENDS
      ArbitraryUserPointer DWORD ?       ;14
      Self            DWORD ?            ;18
      Unknown1C       DWORD ?            ;1C
      ClientId        CLIENT_ID <>       ;20
      Unknown28       DWORD ?            ;28
      pTlsArray       DWORD ?            ;2C
      pPEB            DWORD ?            ;30
      LastError       DWORD ?            ;34  Get/SetLastError
      Unknown34       DWORD 023H DUP (?) ;38
      Locale          DWORD ?            ;C4
      UnknownC8       DWORD 2CCH DUP (?) ;C8
      WinStation      UNICODE_STRING <>  ;BF8
      UnknownC00      DWORD 083H DUP (?) ;C00
      ThreadStack     DWORD ?            ;E0C
      UnknownE10      DWORD 062H DUP (?) ;E10
      LogonLocale     DWORD ?            ;F98
      LogonLocale2    DWORD ?            ;F9C
      UnknownFA0      DWORD 018H DUP (?) ;FA0
     TEB              ENDS
;-----------------------------------------
     SystemBasicInformation = 0
                                      ;EliCZ
     SYSTEM_BASIC_INFORMATION STRUCT DWORD
      Machine             DWORD ? ;pure fantasy; 0 = local ??
      MaximumIncrement    DWORD ?
      PageSize            DWORD ? ;1000
      PhysicalPages       DWORD ? ;KiloBytes = NoPages*(PageSize >> 0A)
      LowestPhysicalPage  DWORD ? ;1
      HighestPhysicalPage DWORD ? ;1FFF
      AllocationGranularity DWORD ? ;10000
      LowestUserAddress   DWORD ? ;10000  ??
      HighestUserAddress  DWORD ? ;7FFEFFFF
      ActiveProcessors    DWORD ? ;mask
      NumberProcessors    BYTE  ?
     SYSTEM_BASIC_INFORMATION ENDS
;-----------------------------------------
     SystemProcessorInformation = 1
                                      ;EliCZ
     SYSTEM_PROCESSOR_INFORMATION STRUCT DWORD
      Architecture        WORD  ?
      Level               WORD  ?
      Revision            WORD  ?
      Reserved06          WORD  ? ;alignment
      FeatureBits         DWORD ?
     SYSTEM_PROCESSOR_INFORMATION ENDS

     FB_FASTSYSCALL       EQU  1000H
;-----------------------------------------
     SystemPerformanceInformation = 2
                                      ;EliCZ
     SYSTEM_PERFORMANCE_INFORMATION STRUCT DWORD
      IdleTime                QWORD ?  ;00
      ReadTransferCount       QWORD ?  ;08  ;Io data
      WriteTransferCount      QWORD ?  ;10
      OtherTransferCount      QWORD ?  ;18
      ReadOperationCount      DWORD ?  ;20
      WriteOperationCount     DWORD ?  ;24
      OtherOperationCount     DWORD ?  ;28
      AvailablePages          DWORD ?  ;2C  ;Mm data
      TotalCommittedPages     DWORD ?  ;30
      TotalCommitLimit        DWORD ?  ;34
      PeakCommitment          DWORD ?  ;38
      MemInfoCounter00        DWORD ?  ;3C
      MemInfoCounter01        DWORD ?  ;40
      MemInfoCounter02        DWORD ?  ;44
      MemInfoCounter03        DWORD ?  ;48
      MemInfoCounter04        DWORD ?  ;4C
      MemInfoCounter05        DWORD ?  ;50
      MemInfoCounter06        DWORD ?  ;54
      MemInfoCounter07        DWORD ?  ;58
      MemInfoCounter08        DWORD ?  ;5C
      MemInfoCounter09        DWORD ?  ;60
      MemInfoCounter10        DWORD ?  ;64
      MemInfoCounter11        DWORD ?  ;68
      MemInfoCounter12        DWORD ?  ;6C
      PagedPoolSize           DWORD ?  ;70
      NonpagedPoolSize        DWORD ?  ;74
      PoolUsage02             DWORD ?  ;78
      PoolUsage03             DWORD ?  ;7C
      PoolUsage05             DWORD ?  ;80
      PoolUsage06             DWORD ?  ;84
      TotalFreeSystemPtes     DWORD ?  ;88
      SystemCodePage          DWORD ?  ;8C
      TotalSystemDriverPages  DWORD ?  ;90
      TotalSystemCodePages    DWORD ?  ;94
      PoolUsage07             DWORD ?  ;98
      PoolUsage04             DWORD ?  ;9C
      UnknownA0               DWORD ?  ;A0
      SystemCachePage         DWORD ?  ;A4
      PagedPoolUsage          DWORD ?  ;A8
      SystemDriverPage        DWORD ?  ;AC
      FastReadNoWait          DWORD ?  ;B0  ;Cc data
      FastReadWait            DWORD ?  ;B4
      FastReadResourceMiss    DWORD ?  ;B8
      FastReadNotPossible     DWORD ?  ;BC
      FastMdlReadNoWait       DWORD ?  ;C0
      FastMdlReadWait         DWORD ?  ;C4
      FastMdlReadResourceMiss DWORD ?  ;C8
      FastMdlReadNotPossible  DWORD ?  ;CC
      MapDataNoWait           DWORD ?  ;D0
      MapDataWait             DWORD ?  ;D4
      MapDataNoWaitMiss       DWORD ?  ;D8
      MapDataWaitMiss         DWORD ?  ;DC
      PinMappedDataCount      DWORD ?  ;E0
      PinReadNoWait           DWORD ?  ;E4
      PinReadWait             DWORD ?  ;E8
      PinReadNoWaitMiss       DWORD ?  ;EC
      PinReadWaitMiss         DWORD ?  ;F0
      CopyReadNoWait          DWORD ?  ;F4
      CopyReadWait            DWORD ?  ;F8
      CopyReadNoWaitMiss      DWORD ?  ;FC
      CopyReadWaitMiss        DWORD ?  ;100
      MdlReadNoWait           DWORD ?  ;104
      MdlReadWait             DWORD ?  ;108
      MdlReadNoWaitMiss       DWORD ?  ;10C
      MdlReadWaitMiss         DWORD ?  ;110
      ReadAheadIos            DWORD ?  ;114
      LazyWriteIos            DWORD ?  ;118
      LazyWritePages          DWORD ?  ;11C
      DataFlushes             DWORD ?  ;120
      DataPages               DWORD ?  ;124
      ContextSwaps            DWORD ?  ;128  yes!
      PCRB4AC                 DWORD ?  ;12C  don't know
      PCRB4B8                 DWORD ?  ;130  don't know
      SyscallsCalled          DWORD ?  ;134  yes!
     SYSTEM_PERFORMANCE_INFORMATION ENDS
;-----------------------------------------
     SystemTimeInformation    = 3
                                      ;EliCZ
     SYSTEM_TIME_INFORMATION STRUCT
      BootTime            QWORD ?
      SystemTime          QWORD ?
      TimeZoneBias        QWORD ?
      CurrentTimeZoneId   QWORD ?
      BootTimeBias        QWORD ?
      InterruptTimeBias   QWORD ?
     SYSTEM_TIME_INFORMATION ENDS
;-----------------------------------------
     SystemPathInformation = 4  ;available via shared user data
;-----------------------------------------
     SystemProcessInformation = 5
                                      ;EliCZ
     THREAD_INFO_OFFSET    EQU 024H
     THREAD_INFO_SIZE      EQU 040H
     NT4_PROCESS_INFO_SIZE EQU 088H
     NT5_PROCESS_INFO_SIZE EQU 0B8H

    ;Thread states:
     TS_INITIALIZED    EQU 0
     TS_READY          EQU 1
     TS_RUNNING        EQU 2
     TS_STANDBY        EQU 3
     TS_TERMINATED     EQU 4
     TS_WAITING        EQU 5
     TS_TRANSITION     EQU 6
     TS_MAX            EQU 7

    ;Wait reasons (TS_WAITING):
     WR_EXECUTIVE      EQU 0
     WR_FREEPAGE       EQU 1
     WR_PAGEIN         EQU 2
     WR_POOLALLOC      EQU 3
     WR_DELAYEXEC      EQU 4
     WR_SUSPENDED      EQU 5
     WR_USERREQUEST    EQU 6
     ;7=0, 8=1, ... 13=6
     WR_EXECUTIVE_     EQU 7
     WR_FREEPAGE_      EQU 8
     WR_PAGEIN_        EQU 9
     WR_POOLALLOC_     EQU 10
     WR_DELAYEXEC_     EQU 11
     WR_SUSPENDED_     EQU 12
     WR_USERREQUEST_   EQU 13
     WR_EVENTPAIRHIGH  EQU 14
     WR_EVENTPAIRLOW   EQU 15  ;user wait for work queue
     WR_LPCRECEIVE     EQU 16
     WR_LPCREPLY       EQU 17
     WR_VIRTMEMORY     EQU 18
     WR_PAGEOUT        EQU 19
     WR_SPARE1         EQU 20
     WR_SPARE2         EQU 21
     WR_SPARE3         EQU 22
     WR_SPARE4         EQU 23
     WR_SPARE5         EQU 24
     WR_SPARE6         EQU 25
     WR_SPARE7         EQU 26
     WR_MAX            EQU 27


     SYSTEM_THREAD_INFORMATION STRUCT  ;size THREAD_INFO_SIZE
      KernelTime       QWORD ?           ;00
      UserTime         QWORD ?           ;08
      CreateTime       QWORD ?           ;10
      TickCount        DWORD ?           ;18
      StartAddress     DWORD ?           ;1C
      ClientId         CLIENT_ID <>      ;20
      DynamicPriority  DWORD ?           ;28
      BasePriority     DWORD ?           ;2C
      ContextSwitches  DWORD ?           ;30
      State            DWORD ?           ;34
      WaitReason       DWORD ?           ;38
      Reserved3C       DWORD ?           ;3C
     SYSTEM_THREAD_INFORMATION ENDS

     ;every process info is in block
     ;Unfortunately I lost my notes on missing structure members (context switches,
     ;faults, starting addresses, user and kernel time, working set size,number of handles..)

     NT4_SYSTEM_PROCESS_INFORMATION STRUCT
      SizeOfBlock                DWORD ?           ;00 NULL for info end
      ThreadCount                DWORD ?           ;04 number of threads in this block
      Reserved08                 DWORD 06H DUP (?) ;08
      CreateTime                 QWORD ?           ;20
      UserTime                   QWORD ?           ;28
      KernelTime                 QWORD ?           ;30
      ProcessName                UNICODE_STRING <> ;38
      Priority                   DWORD ?           ;40
      ProcessId                  DWORD ?           ;44
      ParentProcessId            DWORD ?           ;48
      HandleCount                DWORD ?           ;4C
      SessionId                  DWORD ?           ;50 ??
      Reserved54                 DWORD ?           ;54
      PeakVirtualSize            DWORD ?           ;58
      VirtualSize                DWORD ?           ;5C
      PageFaultCount             DWORD ?           ;60
      PeakWorkingSetSize         DWORD ?           ;64
      WorkingSetSize             DWORD ?           ;68
      QuotaPeakPagedPoolUsage    DWORD ?           ;6C
      QuotaPagedPoolUsage        DWORD ?           ;70
      QuotaPeakNonPagedPoolUsage DWORD ?           ;74
      QuotaNonPagedPoolUsage     DWORD ?           ;78
      PagefileUsage              DWORD ?           ;7C
      PeakPagefileUsage          DWORD ?           ;80
      PrivatePages               DWORD ?           ;84
      ;follows array of SYSTEM_THREAD_INFORMATIONs
      ThreadInformation SYSTEM_THREAD_INFORMATION <> ;88
     NT4_SYSTEM_PROCESS_INFORMATION ENDS

     NT5_SYSTEM_PROCESS_INFORMATION STRUCT
      SizeOfBlock                DWORD ?           ;00 NULL for info end
      ThreadCount                DWORD ?           ;04 number of threads in this block
      Reserved08                 DWORD 06H DUP (?) ;08
      CreateTime                 QWORD ?           ;20
      UserTime                   QWORD ?           ;28
      KernelTime                 QWORD ?           ;30
      ProcessName                UNICODE_STRING <> ;38
      Priority                   DWORD ?           ;40
      ProcessId                  DWORD ?           ;44
      ParentProcessId            DWORD ?           ;48
      HandleCount                DWORD ?           ;4C
      SessionId                  DWORD ?           ;50 ??
      Reserved54                 DWORD ?           ;54
      PeakVirtualSize            DWORD ?           ;58
      VirtualSize                DWORD ?           ;5C
      PageFaultCount             DWORD ?           ;60
      PeakWorkingSetSize         DWORD ?           ;64
      WorkingSetSize             DWORD ?           ;68
      QuotaPeakPagedPoolUsage    DWORD ?           ;6C
      QuotaPagedPoolUsage        DWORD ?           ;70
      QuotaPeakNonPagedPoolUsage DWORD ?           ;74
      QuotaNonPagedPoolUsage     DWORD ?           ;78
      PagefileUsage              DWORD ?           ;7C
      PeakPagefileUsage          DWORD ?           ;80
      PrivatePages               DWORD ?           ;84
      ReadOperationCount         QWORD ?           ;88
      WriteOperationCount        QWORD ?           ;90
      OtherOperationCount        QWORD ?           ;98
      ReadTransferCount          QWORD ?           ;A0
      WriteTransferCount         QWORD ?           ;A8
      OtherTransferCount         QWORD ?           ;B0
      ;follows array of SYSTEM_THREAD_INFORMATIONs
      ThreadInformation SYSTEM_THREAD_INFORMATION <> ;B8
     NT5_SYSTEM_PROCESS_INFORMATION ENDS

   IFDEF NT4
     SYSTEM_PROCESS_INFORMATION TEXTEQU <NT4_SYSTEM_PROCESS_INFORMATION>
   ELSE
     SYSTEM_PROCESS_INFORMATION TEXTEQU <NT5_SYSTEM_PROCESS_INFORMATION>
   ENDIF
;-----------------------------------------
     SystemSyscallInformation = 9

     ;Pointer in shadow table (at offset 4) must not be NULL (when this becomes?)
     ;Copied are dwords from this pointer

     SYSTEM_SYSCALL_INFORMATION STRUCT  ;EliCZ
      SizeOfBlock         DWORD ?
      SyscallTables       DWORD ?
      SizeOfTable00       DWORD ?  ;in dwords
      ;etc.. SizeOfTable(SyscallTables-1)
      ;follow copied tables:
      ;Table00 DWORD SizeOfTable00 DUP (?)
      ;etc.. Table(SyscallTables-1) DWORD SizeOfTable(SyscallTables-1) DUP (?)
     SYSTEM_SYSCALL_INFORMATION ENDS
;-----------------------------------------
     SystemGlobalFlagInformation = 9

     SYSTEM_GLOBALFLAG_INFORMATION STRUCT  ;EliCZ
      GlobalFlag             DWORD ?
     SYSTEM_GLOBALFLAG_INFORMATION ENDS
;-----------------------------------------
     SystemLoadedModuleInformation = 11

     SYSTEM_LOADEDMODULE STRUCT      ;EliCZ
      Unknown00       DWORD ?  ;00
      Unknown04       DWORD ?  ;04
      ModuleBase      DWORD ?  ;08
      ModuleSize      DWORD ?  ;0C
      Unknown10       DWORD ?  ;10
      Unknown14       DWORD ?  ;14
      Unknown18        WORD ?  ;18
      BaseNameOffset   WORD ?  ;1A
      ModuleFileName  CHAR 100H DUP (?) ;1C always ansi
     SYSTEM_LOADEDMODULE ENDS

     SYSTEM_LOADEDMODULE_INFORMATION STRUCT
      ModuleCount     DWORD ?
     ;follows array of SYSTEM_LOADEDMODULE structures
      ModuleInformation  SYSTEM_LOADEDMODULE <>  ;04
     SYSTEM_LOADEDMODULE_INFORMATION ENDS
;-----------------------------------------
     SystemHandleInformation = 16

      OT_DIRECTORY     = 02
      OT_SYMLINK       = 03
      OT_TOKEN         = 04
      OT_PROCESS       = 05
      OT_THREAD        = 06
      OT_JOB           = 07
      OT_EVENT         = 08
      OT_EVENTPAIR     = 09
      OT_MUTANT        = 10
      ;channel auditalarm ?
      OT_SEMAPHORE     = 12
      OT_TIMER         = 13
      OT_PROFILE       = 14
      OT_WINSTATION    = 15
      OT_DESKTOP       = 16
      OT_SECTION       = 17
      OT_KEY           = 18
      OT_PORT          = 19
      OT_WAIT          = 20
      OT_ADAPTER       = 21
      OT_CONTINUATION  = 22
      OT_DEVICE        = 23
      ;channel auditalarm ?
      OT_IOCOMPLETION  = 25
      OT_FILE          = 26

     SYSTEM_HANDLE    STRUCT   ;EliCZ
      ProcessId       DWORD ?
      ObjectType       BYTE ?
      Flags            BYTE ? ;0..7
      Handle           WORD ?
      ObjectPointer   DWORD ?
      Access          DWORD ?
     SYSTEM_HANDLE    ENDS

     SYSTEM_HANDLE_INFORMATION STRUCT
      HandleCount        DWORD ?
     ;follows array of SYSTEM_HANDLE structures
      HandleInformation  SYSTEM_HANDLE <>
     SYSTEM_HANDLE_INFORMATION ENDS
;-----------------------------------------
     SystemObjectInformation = 17  ;to be done

     SYSTEM_OBJECT_INFORMATION STRUCT  ;EliCZ
     SYSTEM_OBJECT_INFORMATION ENDS
;-----------------------------------------
     SystemPageFileInformation = 18

     SYSTEM_PAGEFILE_INFORMATION STRUCT ;EliCZ
      SizeOfBlock       DWORD ?    ;00  NULL for info end
      CurrentSize       DWORD ?    ;04  in pages
      TotalUsedPages    DWORD ?    ;08  in pages
      PeakUsedPages     DWORD ?    ;0C  in pages
      PagefileName      UNICODE_STRING <> ;10
     SYSTEM_PAGEFILE_INFORMATION ENDS
;-----------------------------------------
     SystemDebuggerInformation = 35

     SYSTEM_DEBUGGER_INFORMATION STRUCT  ;EliCZ
      KernelDebuggerEnabled    BYTE ?   ;i386kd
      KernelDebuggerNotPresent BYTE ?
     SYSTEM_DEBUGGER_INFORMATION ENDS
;-----------------------------------------
     ProcessBasicInformation  = 0

     PROCESS_BASIC_INFORMATION STRUCT  ;NTDDK
      ExitStatus       DWORD ?
      PebBaseAddress   DWORD ?
      AffinityMask     DWORD ?
      BasePriority     DWORD ?
      UniqueProcessId  DWORD ?
      InheritedFromUniqueProcessId DWORD ?
     PROCESS_BASIC_INFORMATION ENDS
;-----------------------------------------
     ProcessQuotaLimits = 1

     QUOTA_LIMITS  STRUCT   ;NTDDK corrected by EliCZ: size must be 20H
      PagedPoolLimit         DWORD ?
      NonPagedPoolLimit      DWORD ?
      MinimumWorkingSetSize  DWORD ?
      MaximumWorkingSetSize  DWORD ?
      PagefileLimit          DWORD ?
      Reserved14             DWORD ?   ;added (probably qword alignment)
      TimeLimit              QWORD ?
     QUOTA_LIMITS  ENDS
;-----------------------------------------
     ProcessIoCounters  = 2

     IO_COUNTERS  STRUCT  ;NTDDK corrected by EliCZ: NT4 :NOT_SUPPORTED, NT5: long integers
      ReadOperationCount   QWORD ? ;DWORD ?
      WriteOperationCount  QWORD ? ;DWORD ?
      OtherOperationCount  QWORD ? ;DWORD ?
      ReadTransferCount    QWORD ?
      WriteTransferCount   QWORD ?
      OtherTransferCount   QWORD ?
     IO_COUNTERS  ENDS
;-----------------------------------------
     ProcessVmCounters = 3

     VM_COUNTERS  STRUCT           ;NTDDK
      PeakVirtualSize               DWORD ?
      VirtualSize                   DWORD ?
      PageFaultCount                DWORD ?
      PeakWorkingSetSize            DWORD ?
      WorkingSetSize                DWORD ?
      QuotaPeakPagedPoolUsage       DWORD ?
      QuotaPagedPoolUsage           DWORD ?
      QuotaPeakNonPagedPoolUsage    DWORD ?
      QuotaNonPagedPoolUsage        DWORD ?
      PagefileUsage                 DWORD ?
      PeakPagefileUsage             DWORD ?
     VM_COUNTERS   ENDS
;-----------------------------------------
     ProcessTimes = 4

     KERNEL_USER_TIMES STRUCT  ;NTDDK
      CreateTime    QWORD ?
      ExitTime      QWORD ?
      KernelTime    QWORD ?
      UserTime      QWORD ?
     KERNEL_USER_TIMES ENDS
;-----------------------------------------
     ProcessPooledUsageAndLimits = 14

     POOLED_USAGE_AND_LIMITS STRUCT ;NTDDK
      PeakPagedPoolUsage       DWORD ?
      PagedPoolUsage           DWORD ?
      PagedPoolLimit           DWORD ?
      PeakNonPagedPoolUsage    DWORD ?
      NonPagedPoolUsage        DWORD ?
      NonPagedPoolLimit        DWORD ?
      PeakPagefileUsage        DWORD ?
      PagefileUsage            DWORD ?
      PagefileLimit            DWORD ?
     POOLED_USAGE_AND_LIMITS ENDS
;-----------------------------------------
     ProcessWorkingSetWatch = 15

     PROCESS_WS_WATCH_INFORMATION STRUCT ;NTDDK
      FaultingPc  DWORD ?
      FaultingVa  DWORD ?
     PROCESS_WS_WATCH_INFORMATION ENDS
;-----------------------------------------
     ProcessDeviceMap = 23

     PROCESS_DEVICEMAP_INFORMATION STRUCT ;NTDDK
        DriveMap  DWORD ?
        DriveType WCHAR 32 DUP (?)
     PROCESS_DEVICEMAP_INFORMATION ENDS
;-----------------------------------------
     ThreadBasicInformation  = 0

     THREAD_BASIC_INFORMATION STRUCT    ;EliCZ
      ExitStatus       DWORD ?
      TebBaseAddress   DWORD ?
      ClientId         CLIENT_ID <>
      AffinityMask     DWORD ?
      BasePriority     DWORD ?
      DynamicPriority  DWORD ?
     THREAD_BASIC_INFORMATION ENDS
;-----------------------------------------
   ABOVE2GB           EQU 08000000H   ;for Windows 9x VirtualAlloc. (c) Matt Pietrek