;@GOTO TRANSLATE


.586P

.MODEL             FLAT, STDCALL

   OPTION          CASEMAP: NONE


   INCLUDE         WINDOWS.inc
   UNICODE         = FALSE
   INCLUDE         APIMACRO.mac

   INCLUDE         ExVMM.inc

   INCLUDELIB      iKERNEL32.lib
   INCLUDELIB      iUSER32.lib


Ring0CS  = 28H
Ring0DS  = 30H
Ring0ES  = 30H


.DATA?
  BytesReturned  DWORD ?
  OutBuf         DWORD ?
  Place          SIGN  40 DUP (?)
.CODE

ALIGN 4
QuasiDDB   VxD_Desc_Block <,,"QS",,,\
                           DDB_HAS_WIN32_SVCS OR \
                           DDB_SYS_CRIT_INIT_DONE OR \
                           DDB_DEVICE_INIT_DONE \
                           ,\ ;OR DDB_DYNAMIC_VXD,\
                           "QUASIVXD",,QuasiControl,,,,,,\
                           ,,QUASI_W32>

 QUASI_W32  DWORD 2, 0
            DWORD QuasiW320, 0
            DWORD QuasiW321, 0

   TEXT     QuasiDev, <\\.\QUASIVXD/0>

   TEXT     W32Test,  <QUASI Win32 services/0>
   TEXT     DIOCTest, <QUASI DIOC/0>
   TEXT     CR0X,     <CR0 = /#0.8X/0>
   TEXT     CR3X,     <CR3 = /#0.8X/0>
   TEXT     VMMV,     <VMM version = /#X/0>
   TEXT     VWIV,     <VWIN32 version = /#X/0>


 PrimaryThread:
   CALL     $+5
   POP      EAX
   SUB      EBP, EBP
   TEST     EAX, EAX
   JNS      Exit     ;presence in the shared memory is crucial
   
   sWin32   ThreadWorks, VMM SHL 16 + VMM_Add_DDB
   TEST     EAX, EAX
   JE       Exit

   iMOV     EDI, wsprintfA
   iMOV     ESI, MessageBoxA     ;do it with standard masm or tasm and win $100

   iWin32   KERNEL32_ORD_0001, "QS" SHL 16 + GetCR0
   cWin32   EDI, OFFSET Place, sCR0X, EAX
   sWin32   ESI, EBP, OFFSET Place, sW32Test, EBP

   iWin32   KERNEL32_ORD_0001, "QS" SHL 16 + GetCR3
   cWin32   EDI, OFFSET Place, sCR3X, EAX
   sWin32   ESI, EBP, OFFSET Place, sW32Test, EBP


   iWin32   _lopen, sQuasiDev, EBP ;OF_READ
   MOV      EBX, EAX
   INC      EAX
   JE       Failed

   iWin32   DeviceIoControl, EBX, GetVMMVer, EBP, EBP, OFFSET OutBuf, SIZEOF OutBuf, OFFSET BytesReturned, EBP
   cWin32   EDI, OFFSET Place, sVMMV, OutBuf
   sWin32   ESI, EBP, OFFSET Place,  sDIOCTest, EBP

   iWin32   DeviceIoControl, EBX, GetVWIN32Ver, EBP, EBP, OFFSET OutBuf, SIZEOF OutBuf, OFFSET BytesReturned, EBP
   cWin32   EDI, OFFSET Place, sVWIV, OutBuf
   sWin32   ESI, EBP, OFFSET Place,  sDIOCTest, EBP

   iWin32   CloseHandle, EBX

  Failed:
   sWin32   ThreadWorks, VMM SHL 16 + VMM_Remove_DDB
   TEST     EAX, EAX
   JE       Failed   ;never end

  Exit:
   iWin32   ExitProcess, EAX

;--------------------------------------------------------------------
ThreadWorks PROC USES EBX ESI, Cmd
   LOCAL    Ctx  :CONTEXT
   LEA      ECX, Cmd
   PUSH     EAX
   iWin32   CreateThread, NULL, NULL, AddRemoveDDB, ECX, NULL, ESP
   TEST     EAX, EAX
   POP      ECX
   JE       CTfailed
   LEA      ESI, Ctx
   MOV      EBX, EAX
   ASSUME   ESI: PTR CONTEXT
   MOV      [ESI].ContextFlags, CONTEXT_CONTROL OR CONTEXT_INTEGER
  @@:
   iWin32   Sleep, 32
   iWin32   GetThreadContext, EBX, ESI
   CMP      [ESI].regEip, StopHere
   JNE      @B
   MOV      [ESI].regCs,  Ring0CS
   ADD      [ESI].regEip, 2
   MOV      [ESI].regEcx, CS
   iWin32   SetThreadContext, EBX, ESI
   ASSUME   ESI: NOTHING
   iWin32   WaitForSingleObject, EBX, INFINITE
   PUSH     EAX
   iWin32   GetExitCodeThread, EBX, ESP
   iWin32   CloseHandle, EBX
   POP      EAX
  CTfailed:
   RET
ThreadWorks ENDP
;--------------------------------------------------------------------
 AddRemoveDDB PROC USES EDI, Param
   StopHere::
   JMP      $

   PUSHp    ECX, R0Fin

;   PUSHp    DS,  ES, Ring0DS, Ring0ES
;   POPc              DS,      ES
   SUB      ESP, 40H  ;make some place on r-0 stack

   MOV      EAX, Param
   MOV      CD20H, 20CDH   ;seems I'm writeable
   PUSH     [EAX]
   POP      VxDpart        ;seems I'm writeable
   JMP      $+2            ;for 486-

   MOV      EDI, OFFSET QuasiDDB
   CD20H    WORD   0
   VxDpart  DWORD  0
   JNC      @F

   SUB      EAX, EAX       ;return FALSE if add/remove failed
   JMP      @1
  @@:
   PUSH     1
   POP      EAX            ;return TRUE if all went OK
  @1:

   ADD      ESP, 40H
;   POPc     DS,  ES
   RETF

  R0Fin:
   RET
 AddRemoveDDB ENDP
;--------------------------------------------------------------------

   GetVMMVer    = 1
   GetVWIN32Ver = 2

 ASSUME     ESI: PTR DIOCParams

 QuasiControl:
   CMP      EAX, W32_DEVICEIOCONTROL
   JNE      Quit_IOCTL
   MOV      EDX, [ESI].dwIoControlCode
   DEC      EDX
   JS       Quit_IOCTL
   CMP      EDX, MaxQuasiFunc
   CMC
   JNC      @F
   RET
  @@:
   CALL     QuasiFunc[EDX*4]
  Quit_IOCTL:
   SUB      EAX, EAX
   RET

  ALIGN     4
   QuasiFunc    DWORD GetVMMVersion, GetVWIN32Version
   MaxQuasiFunc = LENGTHOF QuasiFunc


  GetVMMVersion:
   VMMcall  Get_VMM_Version
   MOV      EDX, [ESI].lpvOutBuffer
   MOV      ECX, [ESI].lpcbBytesReturned
   MOV      [EDX], EAX
   MOV      DWORD PTR [ECX], 4
   RET

  GetVWIN32Version:
   VxDcall  VWIN32, VWIN32_Get_Version
   MOV      EDX, [ESI].lpvOutBuffer
   MOV      ECX, [ESI].lpcbBytesReturned
   MOV      [EDX], EAX
   MOV      DWORD PTR [ECX], 4
   RET

 ASSUME     ESI: NOTHING

;Win32 services --------------------------------------------

 GetCR0   = 0
 GetCR3   = 1

 ASSUME     ECX: PTR Client_Reg_Struc

 QuasiW320  PROC pClRegStr, pcb_s
   MOV      ECX, pClRegStr
   MOV      EAX, CR0
   MOV      [ECX].Client_EAX, EAX
   RET
 QuasiW320  ENDP

 QuasiW321  PROC pClRegStr, pcb_s
   MOV      ECX, pClRegStr
   MOV      EAX, CR3
   MOV      [ECX].Client_EAX, EAX
   RET
 QuasiW321  ENDP

 ASSUME     ECX: NOTHING
;-----------------------------------------------------------

END  PrimaryThread

:TRANSLATE
@ECHO OFF
ML    /c /coff /nologo QuasiVxD.bat
eLINK QuasiVxD /IGNORE:4078 /nologo /SUBSYSTEM:WINDOWS /optidata /merge:.rdata=.text /BASE:0XBF1F0000 /SECTION:.bss,S /SECTION:.text,!P /FIXED:NO
DEL   QuasiVxD.obj
PAUSE
CLS