DDK_VERSION             EQU     400H
UNDEFINED_DEVICE_ID     EQU     00000H
UNDEFINED_INIT_ORDER    EQU     080000000H

DDB_SYS_CRIT_INIT_DONE_BIT	EQU	0
DDB_SYS_CRIT_INIT_DONE	EQU	(1 SHL DDB_SYS_CRIT_INIT_DONE_BIT)
DDB_DEVICE_INIT_DONE_BIT	EQU	1
DDB_DEVICE_INIT_DONE	EQU	(1 SHL DDB_DEVICE_INIT_DONE_BIT)
DDB_HAS_WIN32_SVCS_BIT	EQU	14
DDB_HAS_WIN32_SVCS	EQU	(1 SHL DDB_HAS_WIN32_SVCS_BIT)
DDB_DYNAMIC_VXD_BIT	EQU	15
DDB_DYNAMIC_VXD	EQU	(1 SHL DDB_DYNAMIC_VXD_BIT)
DDB_DEVICE_DYNALINKED_BIT	EQU	13
DDB_DEVICE_DYNALINKED	EQU	(1 SHL DDB_DEVICE_DYNALINKED_BIT)

VxD_Desc_Block  STRUC
DDB_Next        DD      ?
DDB_SDK_Version DW      DDK_VERSION
DDB_Req_Device_Number   DW      UNDEFINED_DEVICE_ID
DDB_Dev_Major_Version   DB      0
DDB_Dev_Minor_Version   DB      0
DDB_Flags       DW      0
DDB_Name        DB      "        "
DDB_Init_Order  DD      UNDEFINED_INIT_ORDER
DDB_Control_Proc        DD      ?
DDB_V86_API_Proc        DD      0
DDB_PM_API_Proc DD      0
DDB_V86_API_CSIP        DD      0
DDB_PM_API_CSIP DD      0
DDB_Reference_Data      DD      ?
DDB_Service_Table_Ptr   DD      0
DDB_Service_Table_Size  DD      0
DDB_Win32_Service_Table DD      0
DDB_Prev        DD      'Prev'
DDB_Size        DD      SIZE(VxD_Desc_Block)
DDB_Reserved1   DD      'Rsv1'
DDB_Reserved2   DD      'Rsv2'
DDB_Reserved3   DD      'Rsv3'
VxD_Desc_Block  ENDS

VMM             EQU 1
Get_VMM_Version EQU 0
VMM_Add_DDB     EQU 0F7H
VMM_Remove_DDB  EQU 0F8H

VWIN32          EQU 2AH
VWIN32_Get_Version  EQU 0

W32_DEVICEIOCONTROL	EQU	0023H

VxDcall  MACRO  VxD, VCALL
 WORD 20CDH, VCALL, VxD
ENDM

VMMcall  MACRO  VCALL
 VxDcall VMM, VCALL
ENDM




Client_Reg_Struc	STRUC
Client_EDI	DD	?
Client_ESI	DD	?
Client_EBP	DD	?
Client_res0	DD	?
Client_EBX	DD	?
Client_EDX	DD	?
Client_ECX	DD	?
Client_EAX	DD	?
Client_Error	DD	?
Client_EIP	DD	?
Client_CS	DW	?
Client_res1	DW	?
Client_EFlags	DD	?
Client_ESP	DD	?
Client_SS	DW	?
Client_res2	DW	?
Client_ES	DW	?
Client_res3	DW	?
Client_DS	DW	?
Client_res4	DW	?
Client_FS	DW	?
Client_res5	DW	?
Client_GS	DW	?
Client_res6	DW	?
Client_Alt_EIP	DD	?
Client_Alt_CS	DW	?
Client_res7	DW	?
Client_Alt_EFlags	DD	?
Client_Alt_ESP	DD	?
Client_Alt_SS	DW	?
Client_res8	DW	?
Client_Alt_ES	DW	?
Client_res9	DW	?
Client_Alt_DS	DW	?
Client_res10	DW	?
Client_Alt_FS	DW	?
Client_res11	DW	?
Client_Alt_GS	DW	?
Client_res12	DW	?
Client_Reg_Struc	ENDS

PC_FIXED	EQU	00000008H
PC_LOCKED	EQU	00000080H
PC_LOCKEDIFDP	EQU	00000100H
PC_WRITEABLE	EQU	00020000H
PC_USER	EQU	00040000H
PC_INCR	EQU	40000000H
PC_PRESENT	EQU	80000000H
PC_STATIC	EQU	20000000H
PC_DIRTY	EQU	08000000H
PCC_ZEROINIT	EQU	00000001H
PCC_NOLIN	EQU	10000000H

DIOCParams	STRUC
Internal1	DD	?
VMHandle	DD	?
Internal2	DD	?
dwIoControlCode	DD	?
lpvInBuffer	DD	?
cbInBuffer	DD	?
lpvOutBuffer	DD	?
cbOutBuffer	DD	?
lpcbBytesReturned	DD	?
lpoOverlapped	DD	?
hDevice	DD	?
tagProcess	DD	?
DIOCParams	ENDS
