;@GOTO TRANSLATE

   ;"Close Program" dialog appears in W9X after pressing Ctrl+Alt+Del.
   ;It contains processess which can be terminated by user.
   ;It doesn't contain processess with fServiceProcess flag set in
   ;the process database.
   ;ShowAllInCloseProgram clears fServiceProcess flag of all currently
   ;running processess =>  processess (but kernel32.dll) will he showed
   ;in the dialog.
   ;HideAllInCloseProgram marks all currently running processess as
   ;services =>  processess will not be showed in the dialog.

.586P

.MODEL		   FLAT, STDCALL

   OPTION	   CASEMAP: NONE


   INCLUDE	   WINDOWS.inc
   UNICODE	   = FALSE
   INCLUDE	   APIMACRO.mac


   INCLUDELIB	   iKERNEL32.lib
   INCLUDELIB	   iUSER32.lib


   ;If equate STANDARD is defined, RegisterServiceProcess is used
   ;otherwise process database is modified directly.
   ;The 1st method is better.

.DATA?
IFNDEF STANDARD
   Obsfucator      DWORD  ? 
ENDIF
   PIDarraysize    EQU    1000H
   PIDarray        DWORD  PIDarraysize/4 DUP (?) 
     
.CODE
   TEXT      K32,  <KERNEL32.dll/0>
   TEXTA     CT32S,<CreateToolhelp32Snapshot/0>
   TEXTA     P32F, <Process32First/0>
   TEXTA     P32N, <Process32Next/0>
IFDEF STANDARD
   TEXTA     RSP,  <RegisterServiceProcess/0>
ENDIF

 PrimaryThread:
IFDEF STANDARD
   iWin32i   GetModuleHandle, sK32
   iWin32    GetProcAddress, EAX, sRSP
   TEST      EAX, EAX
   JE        Quit
   MOV       EDI, EAX
ELSE
   iWin32    GetVersion
   TEST      EAX, EAX
   JNS       Quit
ENDIF

   MOV       ESI, OFFSET PIDarray
IFNDEF STANDARD
   PUSH      OFFSET Obsfucator
ENDIF
   sWin32    GetCurrentPIDs9x, ESI, SIZEOF PIDarray
   TEST      EAX, EAX
   JE        Quit
   MOV       EBX, EAX       ;total number of processes

   @@:
   LODSD
IFDEF STANDARD
  IFNDEF HIDE
   ;BOOL RegisterServiceProcess(DWORD dwProcessId, BOOL Register);
   ;if dwProcessId == 0 then dwProcessId <- CurrentProcessId
   sWin32    EDI, EAX, FALSE   ;FALSE = unregister = clear fServiceProcess bit
  ELSE                         ;      = don't hide process/window name in Close Program
   sWin32    EDI, EAX, TRUE    ;TRUE  = register = set fServiceProcess bit
  ENDIF                        ;      = hide process/window name in Close Program 
ELSE
   XOR       EAX, Obsfucator           ;EAX <- process database (PDB)
  IFNDEF HIDE                          ;EAX+20H == PDB.flags DWORD
   AND       BYTE PTR [EAX+21H], NOT 1 ;clear fServiceProcess flag
  ELSE                                 ;fServiceProcess flag = 100H
   OR        BYTE PTR [EAX+21H], 1     ;set fServiceProcess flag
  ENDIF
ENDIF
   DEC       EBX
   JG        @B             

 Quit:  
   iWin32    ExitProcess, EAX

;---------------------------------------------------------------------
IFDEF STANDARD
 GetCurrentPIDs9x PROC  USES EBX ESI EDI, PIDbuffer, PIDbuffersize
ELSE
 GetCurrentPIDs9x PROC  USES EBX ESI EDI, PIDbuffer, PIDbuffersize,\
                                          PObsfucator
ENDIF
   SnapShot  EQU       PIDbuffer
   LOCAL     PIDCount :DWORD
   LOCAL     Process  :PROCESSENTRY32

   AND       PIDCount, 0
   iMOV      ESI, GetProcAddress
   MOV       EDI, PIDbuffer
   SHR       PIDbuffersize, 2   

   iWin32i   GetModuleHandle, sK32
   TEST      EAX, EAX
   JE        GetAllPIDsEnd
   MOV       EBX, EAX
   sWin32    ESI, EBX, sCT32S
   TEST      EAX, EAX
   JE        GetAllPIDsEnd
   sWin32    EAX, TH32CS_SNAPPROCESS, 0
   CMP       EAX, -1
   JE        GetAllPIDsEnd
   MOV       SnapShot, EAX
   sWin32    ESI, EBX, sP32N
   TEST      EAX, EAX
   JE        Tidy
   PUSH      EAX
   sWin32    ESI, EBX, sP32F
   TEST      EAX, EAX
   POP       ESI
   JE        Tidy
   LEA       EBX, Process
   ASSUME    EBX: PTR PROCESSENTRY32 
   MOV       [EBX].dwSize, SIZEOF PROCESSENTRY32

   sWin32    EAX, SnapShot, EBX
IFNDEF STANDARD
   MOV       ECX, PObsfucator
   PUSH	     [EBX].th32ParentProcessID
   POP	     [ECX]
ENDIF
  CheckProc:
   TEST      EAX, EAX
   JE	     Tidy
   DEC       PIDbuffersize
   JL        Tidy       
   MOV	     EAX, [EBX].th32ProcessID
   INC       PIDCount
   STOSD
   sWin32    ESI, SnapShot, EBX
   JMP	     CheckProc
   ASSUME    EBX: NOTHING
  Tidy:
   iWin32    CloseHandle, SnapShot    
  GetAllPIDsEnd:
   MOV       EAX, PIDCount
   RET
 GetCurrentPIDs9x ENDP

END  PrimaryThread

:TRANSLATE
@ECHO OFF
REM ML    /c /coff /nologo ShowAllInCloseProgram.bat
ML    /c /coff /nologo /DSTANDARD ShowAllInCloseProgram.bat
LINK  ShowAllInCloseProgram /IGNORE:4078 /nologo /SUBSYSTEM:WINDOWS /MERGE:.idata=.text
REM ML    /c /coff /nologo /DHIDE ShowAllInCloseProgram.bat
ML    /c /coff /nologo /DHIDE /DSTANDARD ShowAllInCloseProgram.bat
LINK  ShowAllInCloseProgram /OUT:HideAllInCloseProgram.exe /IGNORE:4078 /nologo /SUBSYSTEM:WINDOWS /MERGE:.idata=.text
DEL   ShowAllInCloseProgram.obj
PAUSE
CLS