;@goto translate


.586P

.MODEL            FLAT, STDCALL

   OPTION         CASEMAP: NONE

   INCLUDE        WINDOWS.inc
   INCLUDE        APIMACRO.mac

   INCLUDELIB     iKERNEL32_9x.lib
   INCLUDELIB     iUSER32.lib



.DATA?
   PatchPEoffset  = 1000H + 003CH  ;RUNTIMELIC!.text+3CH
   PatchSize      = 1

   process        PROCESSENTRY32         <> 
   module         MODULEENTRY32          <> 
   sBuffer        BYTE  PatchSize    DUP (?)


.CODE
   RunTimeLic     BYTE  "RUNTIMELIC.DLL", NULL
  ALIGN 4
   sTitle         BYTE  "Installation patch", NULL 
  ALIGN 4
   ErrWindows     BYTE  "Windows failed!", NULL 
  ALIGN 4
   ErrNotFound    BYTE  "Module not found!", NULL 
  ALIGN 4
   ErrProcess     BYTE  "Accessing process failed!", NULL 
  ALIGN 4
   ErrPatch       BYTE  "Incorrect module version!", NULL 
  ALIGN 4
   Done           BYTE  "Done.", NULL 

  ALIGN 4
   WantedValues   BYTE  85H

   OriginalValues BYTE  84H

 Start:
   ASSUME    ESI: PTR PROCESSENTRY32
   ASSUME    EDI: PTR MODULEENTRY32
   MOV       ESI, OFFSET process
   MOV       EDI, OFFSET module
   SUB       EBP, EBP
   iWin32    CreateToolhelp32Snapshot, TH32CS_SNAPPROCESS, 0
   MOV       EBX, EAX
   INC       EAX
   JE        ErrorWindows

   MOV       [ESI].dwSize, SIZEOF PROCESSENTRY32
   iWin32    Process32First, EBX, ESI
  CheckProc:

   ;here compare "process name" (PROCESSENTRY32.szExeFile) with 
   ;"your process name" if needed  - but there is path included!

   TEST      EAX, EAX
   JE        Fin

   iWin32    CreateToolhelp32Snapshot, TH32CS_SNAPMODULE, [ESI].th32ProcessID
   MOV       EBP, EAX
   INC       EAX
   JE        NextProc

   MOV       [EDI].dwSize, SIZEOF MODULEENTRY32
   iWin32    Module32First, EBP, EDI
  @@:
   TEST      EAX, EAX
   JE        @f 

   LEA       EAX, [EDI].szModule
   iWin32    lstrcmpiA, OFFSET RunTimeLic, EAX
   TEST      EAX, EAX
   SETE       AL
   JE        @f
   MOV       [EDI].dwSize, SIZEOF MODULEENTRY32
   iWin32    Module32Next, EBP, EDI
   JMP       @b

  @@:
   PUSH      EAX
   iWin32    CloseHandle, EBP
   POP       EBP
   TEST      EBP, EBP
   JNE       Fin 
  NextProc:
   MOV       [ESI].dwSize, SIZEOF PROCESSENTRY32
   iWin32    Process32Next, EBX, ESI
   JMP       CheckProc

  Fin:
   iWin32    CloseHandle, EBX
   TEST      EBP, EBP
   JE        ErrorNotFound

                          ;if problems occur add OR STANDARD_RIGHTS_REQUIRED
   iWin32    OpenProcess, PROCESS_VM_READ OR PROCESS_VM_WRITE OR \
                          PROCESS_VM_OPERATION OR PROCESS_QUERY_INFORMATION,\
                          FALSE,\
                          [EDI].th32ProcessID
                          ;READ and WRITE is enough for Win95


   MOV       ECX, [EDI].modBaseAddr
   MOV       EBP, EAX
   LEA       EBX, [ECX+PatchPEoffset]
   TEST      EAX, EAX
   MOV       ESI, OFFSET sBuffer
   JE        ErrorWindows


   PUSH      EAX
   iWin32    ReadProcessMemory, EBP, EBX, ESI, PatchSize, ESP
   TEST      EAX, EAX
   POP       ECX
   JE        ErrorProc
   CMP       ECX, PatchSize
   CLD
   MOV       EDI, OFFSET OriginalValues
   JNE       ErrorProc

   REPE      CMPSB
   JNE       ErrorPatch

   ;note that RUNTIMELIC!.text  is not writable
   PUSH      EAX
   iWin32    WriteProcessMemory, EBP, EBX, OFFSET WantedValues, PatchSize, ESP
   TEST      EAX, EAX
   POP       ECX
   JE        ErrorProc
   CMP       ECX, PatchSize
   JNE       ErrorProc

   MOV       ESI, OFFSET Done
   JMP       @f
  ErrorProc:
   MOV       ESI, OFFSET ErrProcess
   JMP       @f
  ErrorPatch:
   MOV       ESI, OFFSET ErrPatch
  @@:
   iWin32    CloseHandle, EBP
   JMP       Exitus
  ErrorNotFound:
   MOV       ESI, OFFSET ErrNotFound
   JMP       Exitus
  ErrorWindows:
   MOV       ESI, OFFSET ErrWindows
  Exitus:
   iWin32    MessageBoxA, NULL, ESI, OFFSET sTitle, MB_ICONINFORMATION 
   iWin32    ExitProcess, NULL



END Start

:translate
@echo off
ML   /c /coff /nologo instpatch.bat
LINK instpatch /nologo /ALIGN:0X1000 /SUBSYSTEM:WINDOWS /RELEASE /MERGE:.rdata=.text /IGNORE:4108,4078
DEL  instpatch.obj