;@goto translate


.586P

.MODEL            FLAT, STDCALL

   OPTION         CASEMAP: NONE

   UNICODE        = 1
   ARGUMENTS      = 0
   INCLUDE        W32MAIN.inc
   INCLUDE        APIMACRO.mac

   INCLUDELIB     iKERNEL32.lib
   INCLUDELIB     iUSER32.lib
   INCLUDELIB     iPSAPI.lib



.DATA?
   PatchPEoffset  =       1000H + 003CH  ;RUNTIMELIC!.text+003C
   PatchSize      =       1

   ProcArraySize  EQU     1000H
   ModArraySize   EQU     1000H

   process        DWORD   ProcArraySize/4 DUP (?) 
   module         HMODULE ProcArraySize/4 DUP (?) 

   ExaminedProcess DWORD  ?

   MODULEINFO     STRUCT
    lpBaseOfDll   DWORD   ?
    SizeOfImage   DWORD   ?
    EntryPoint    DWORD   ?
   MODULEINFO     ENDS

   modinfo        MODULEINFO                  <>

   BaseName       CHAR    256             DUP (?)
   sBuffer        BYTE    PatchSize       DUP (?)


.CODE
   RunTimeLic     LABEL   CHAR
                  STRING  <RUNTIMELIC.DLL/0>
  ALIGN 4
   sTitle         LABEL   CHAR
                  STRING  <Installation patch/0>
  ALIGN 4
   ErrWindows     LABEL   CHAR
                  STRING  <Windows failed/:/0>
  ALIGN 4
   ErrNotFound    LABEL   CHAR
                  STRING  <Module not found/:/0>
  ALIGN 4
   ErrProcess     LABEL   CHAR
                  STRING  <Accessing process failed/:/0>
  ALIGN 4
   ErrPatch       LABEL   CHAR
                  STRING  <Incorrect module version/:/0>
  ALIGN 4
   Done           LABEL   CHAR
                  STRING  <Done./0>

  ALIGN 4
   WantedValues   BYTE    85H

   OriginalValues BYTE    84H


 Start:
   MOV       ESI, OFFSET process
   MOV       EDI, OFFSET module
   PUSH      EAX
   iWin32    EnumProcesses, ESI, ProcArraySize, ESP
   TEST      EAX, EAX
   POP       EBX
   JE        ErrorWindows
   SHR       EBX, 2
   JMP       FirstProcess

  NextProcess:
   iWin32    CloseHandle, ExaminedProcess

  FirstProcess:
   TEST      EBX, EBX
   JE        ErrorNotFound
   LODSD
   DEC       EBX          
                          ;if problems occur add OR STANDARD_RIGHTS_REQUIRED
   iWin32    OpenProcess, PROCESS_VM_READ OR PROCESS_VM_WRITE OR \
                          PROCESS_VM_OPERATION OR PROCESS_QUERY_INFORMATION,\
                          FALSE,\
                          EAX
   TEST      EAX, EAX
   JE        FirstProcess

   PUSH      ECX
   MOV       ExaminedProcess, EAX
   iWin32    EnumProcessModules, EAX, EDI, ModArraySize, ESP
   TEST      EAX, EAX
   POP       EBP
   JE        NextProcess
   SHR       EBP, 2

  NextModule:
   TEST      EBP, EBP
   JE        NextProcess
   iWin32    GetModuleBaseNameW, ExaminedProcess, [EDI],\
                                 OFFSET BaseName, SIZEOF BaseName
   DEC       EBP
   ADD       EDI, SIZEOF HMODULE
   TEST      EAX, EAX
   JE        NextModule

   ;here compare "process name" (usually 1st module name) with 
   ;"your process name" if needed

   iWin32    lstrcmpiW, OFFSET RunTimeLic, OFFSET BaseName
   TEST      EAX, EAX
   JNE       NextModule

   MOV       EBP, ExaminedProcess
   iWin32    GetModuleInformation, EBP, [EDI-SIZEOF HMODULE],\
                                   OFFSET modinfo,  SIZEOF modinfo
   TEST      EAX, EAX
   JE        ErrorProc


   MOV       ECX, modinfo.lpBaseOfDll  ;lpBaseOfDll == HMODULE  so
   TEST      EAX, EAX                  ;GetModuleInformation is not needed here
   LEA       EBX, [ECX+PatchPEoffset]  
   MOV       ESI, OFFSET sBuffer
   JE        ErrorWindows

   PUSH      EAX
   iWin32    ReadProcessMemory, EBP, EBX, ESI, PatchSize, ESP
   TEST      EAX, EAX
   POP       ECX
   JE        ErrorProc
   CMP       ECX, PatchSize
   CLD
   MOV       EDI, OFFSET OriginalValues
   JNE       ErrorProc

   REPE      CMPSB
   JNE       ErrorPatch

   ;note that RUNTIMELIC!.text  is not writable
   PUSH      EAX
   iWin32    WriteProcessMemory, EBP, EBX, OFFSET WantedValues, PatchSize, ESP
   TEST      EAX, EAX
   POP       ECX
   JE        ErrorProc
   CMP       ECX, PatchSize
   JNE       ErrorProc

   MOV       ESI, OFFSET Done
   JMP       @f
  ErrorProc:
   MOV       ESI, OFFSET ErrProcess
   JMP       @f
  ErrorPatch:
   MOV       ESI, OFFSET ErrPatch
  @@:
   iWin32    CloseHandle, EBP
   JMP       Exitus
  ErrorNotFound:
   MOV       ESI, OFFSET ErrNotFound
   JMP       Exitus
  ErrorWindows:
   MOV       ESI, OFFSET ErrWindows
  Exitus:
   iWin32    MessageBoxW, NULL, ESI, OFFSET sTitle, MB_ICONINFORMATION 
   iWin32    ExitProcess, NULL

END Start

:translate
@echo off
ML   /c /coff /nologo instpatchNT4.bat
LINK instpatchNT4 /nologo /ALIGN:0X1000 /SUBSYSTEM:WINDOWS /RELEASE /MERGE:.rdata=.text /IGNORE:4108,4078 /BASE:0X02330000
DEL  instpatchNT4.obj
